/* applet.c generated by valac 0.20.1, the Vala compiler
 * generated from applet.vala, do not modify */

/*
 * Copyright (C) 2009 Michal Hruby <michal.mhr@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Michal Hruby <michal.mhr@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gio/gio.h>
#include <dbus/dbus-glib-lowlevel.h>
#include <dbus/dbus-glib.h>
#include "libawn/libawn.h"
#include <libdesktop-agnostic/config.h>
#include <gtk/gtk.h>
#include <libwnck/libwnck.h>
#include <gdk/gdk.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <glib/gi18n.h>
#include "libawn/awn-utils.h"
#include <float.h>
#include <math.h>


#define TYPE_DOCK_MANAGER (dock_manager_get_type ())
#define DOCK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DOCK_MANAGER, DockManager))
#define IS_DOCK_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DOCK_MANAGER))
#define DOCK_MANAGER_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_DOCK_MANAGER, DockManagerIface))

typedef struct _DockManager DockManager;
typedef struct _DockManagerIface DockManagerIface;

#define TYPE_DOCK_MANAGER_PROXY (dock_manager_proxy_get_type ())
typedef GDBusProxy DockManagerProxy;
typedef GDBusProxyClass DockManagerProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_PREFS_APPLET (prefs_applet_get_type ())
#define PREFS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PREFS_APPLET, PrefsApplet))
#define PREFS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PREFS_APPLET, PrefsAppletClass))
#define IS_PREFS_APPLET(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PREFS_APPLET))
#define IS_PREFS_APPLET_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PREFS_APPLET))
#define PREFS_APPLET_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PREFS_APPLET, PrefsAppletClass))

typedef struct _PrefsApplet PrefsApplet;
typedef struct _PrefsAppletClass PrefsAppletClass;
typedef struct _PrefsAppletPrivate PrefsAppletPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _dbus_g_connection_unref0(var) ((var == NULL) ? NULL : (var = (dbus_g_connection_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _PrefsAppletUpdateTaskmanagerData PrefsAppletUpdateTaskmanagerData;

struct _DockManagerIface {
	GTypeInterface parent_iface;
	void (*get_capabilities) (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
	gchar** (*get_capabilities_finish) (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error);
	void (*awn_set_visibility) (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
	void (*awn_set_visibility_finish) (DockManager* self, GAsyncResult* _res_, GError** error);
};

struct _PrefsApplet {
	AwnAppletSimple parent_instance;
	PrefsAppletPrivate * priv;
};

struct _PrefsAppletClass {
	AwnAppletSimpleClass parent_class;
};

struct _PrefsAppletPrivate {
	DesktopAgnosticConfigClient* panel_client;
	GtkMenu* ctx_menu;
	GList* windows;
	guint timer_id;
	gboolean in_drag;
	guint autohide_cookie;
	AwnApplet* docklet;
	GList* docklet_icons;
};

struct _PrefsAppletUpdateTaskmanagerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GSimpleAsyncResult* _async_result;
	PrefsApplet* self;
	gboolean visible;
	DBusGConnection* _tmp0_;
	DBusGConnection* con;
	DBusGConnection* _tmp1_;
	DBusGProxy* _tmp2_;
	DockManager* taskman;
	DockManager* _tmp3_;
	gint _tmp4_;
	gchar** _tmp5_;
	gchar** caps;
	gint caps_length1;
	gint _caps_size_;
	gboolean supports_visibility_setting;
	gchar** _tmp6_;
	gint _tmp6__length1;
	gchar** cap_collection;
	gint cap_collection_length1;
	gint _cap_collection_size_;
	gint cap_it;
	gchar* _tmp7_;
	gchar* cap;
	const gchar* _tmp8_;
	gboolean _tmp9_;
	DockManager* _tmp10_;
	gboolean _tmp11_;
	GError* err;
	GError * _inner_error_;
};


static gpointer prefs_applet_parent_class = NULL;

#define not_used APPLETSDIR
GType dock_manager_proxy_get_type (void) G_GNUC_CONST;
guint dock_manager_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType dock_manager_get_type (void) G_GNUC_CONST;
void dock_manager_get_capabilities (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
gchar** dock_manager_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error);
void dock_manager_awn_set_visibility (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
void dock_manager_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error);
static void dock_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data);
static void dock_manager_proxy_get_capabilities_async (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_);
static gchar** dock_manager_proxy_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error);
static void dock_manager_proxy_awn_set_visibility_async (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void dock_manager_proxy_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error);
static void dock_manager_proxy_dock_manager_interface_init (DockManagerIface* iface);
static void _dbus_dock_manager_get_capabilities (DockManager* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_dock_manager_get_capabilities_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void _dbus_dock_manager_awn_set_visibility (DockManager* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_dock_manager_awn_set_visibility_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_);
static void dock_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* dock_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean dock_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dock_manager_unregister_object (gpointer user_data);
GType prefs_applet_get_type (void) G_GNUC_CONST;
#define PREFS_APPLET_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_PREFS_APPLET, PrefsAppletPrivate))
enum  {
	PREFS_APPLET_DUMMY_PROPERTY
};
PrefsApplet* prefs_applet_new (const gchar* canonical_name, const gchar* uid, gint panel_id);
PrefsApplet* prefs_applet_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id);
static void prefs_applet_real_constructed (GObject* base);
static void prefs_applet_on_clicked (PrefsApplet* self);
static void _prefs_applet_on_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void prefs_applet_on_context_menu_popup (PrefsApplet* self, GdkEventButton* evt);
static void _prefs_applet_on_context_menu_popup_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self);
static void prefs_applet_on_drag_begin (PrefsApplet* self, GdkDragContext* context);
static void _prefs_applet_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender, GdkDragContext* context, gpointer self);
static void prefs_applet_on_drag_end (PrefsApplet* self, GdkDragContext* context);
static void _prefs_applet_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender, GdkDragContext* context, gpointer self);
static gboolean prefs_applet_on_drag_failed (PrefsApplet* self, GdkDragContext* context, GtkDragResult _result_);
static gboolean _prefs_applet_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender, GdkDragContext* p0, GtkDragResult p1, gpointer self);
static void prefs_applet_initialize_menu (PrefsApplet* self);
static void prefs_applet_taskmanager_appeared (PrefsApplet* self, const gchar* name);
static void _prefs_applet_taskmanager_appeared_awn_dbus_watcher_name_appeared (AwnDBusWatcher* _sender, const gchar* name, gpointer self);
static void prefs_applet_update_taskmanager (PrefsApplet* self, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_);
static void prefs_applet_update_taskmanager_finish (PrefsApplet* self, GAsyncResult* _res_);
static void __lambda12_ (PrefsApplet* self, AwnApplet* w);
static void ___lambda12__awn_applet_applet_deleted (AwnApplet* _sender, gpointer self);
static void prefs_applet_on_quit_click (PrefsApplet* self);
static void _prefs_applet_on_quit_click_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void __lambda11_ (PrefsApplet* self, GtkMenuItem* w);
static void prefs_applet_run_preferences (PrefsApplet* self, gboolean about_only);
static void ___lambda11__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void prefs_applet_update_taskmanager_data_free (gpointer _data);
static gboolean prefs_applet_update_taskmanager_co (PrefsAppletUpdateTaskmanagerData* _data_);
static void prefs_applet_update_taskmanager_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_);
static void prefs_applet_on_active_changed (PrefsApplet* self, WnckWindow* old_active);
static void prefs_applet_on_window_opened (PrefsApplet* self, WnckWindow* window);
static void prefs_applet_update_icon (PrefsApplet* self);
static void prefs_applet_on_window_closed (PrefsApplet* self, WnckWindow* window);
static gboolean prefs_applet_on_timer_tick (PrefsApplet* self);
static gboolean _prefs_applet_on_timer_tick_gsource_func (gpointer self);
void prefs_applet_setup_docklet (PrefsApplet* self, GdkNativeWindow window_id);
void prefs_applet_setup_label_for_docklet (AwnLabel* label, AwnApplet* docklet);
static AwnIcon* prefs_applet_new_unbound_icon (void);
static void __lambda2_ (PrefsApplet* self, GtkObject* w);
static void ___lambda2__gtk_object_destroy (GtkObject* _sender, gpointer self);
static void __lambda3_ (PrefsApplet* self, AwnApplet* w, gint s);
static void ___lambda3__awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self);
static void __lambda4_ (PrefsApplet* self, AwnApplet* w, GtkPositionType p);
static void ___lambda4__awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self);
static void __lambda5_ (PrefsApplet* self, AwnIcon* w);
static void ___lambda5__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void __lambda6_ (PrefsApplet* self, AwnIcon* w);
static void prefs_applet_change_icon_size (PrefsApplet* self, gint new_size);
static void ___lambda6__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void __lambda7_ (PrefsApplet* self, AwnIcon* w);
static void ___lambda7__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void __lambda8_ (PrefsApplet* self, AwnIcon* w);
static void ___lambda8__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void __lambda9_ (PrefsApplet* self, AwnIcon* w);
static void ___lambda9__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void __lambda10_ (PrefsApplet* self, AwnIcon* w);
static void ___lambda10__awn_icon_clicked (AwnIcon* _sender, gpointer self);
static GObject * prefs_applet_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void _prefs_applet_on_window_opened_wnck_screen_window_opened (WnckScreen* _sender, WnckWindow* window, gpointer self);
static void _prefs_applet_on_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self);
static void _prefs_applet_on_active_changed_wnck_screen_active_window_changed (WnckScreen* _sender, WnckWindow* previous_window, gpointer self);
static void prefs_applet_finalize (GObject* obj);
AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GDBusArgInfo _dock_manager_dbus_arg_info_get_capabilities_result = {-1, "result", "as"};
static const GDBusArgInfo * const _dock_manager_dbus_arg_info_get_capabilities_in[] = {NULL};
static const GDBusArgInfo * const _dock_manager_dbus_arg_info_get_capabilities_out[] = {&_dock_manager_dbus_arg_info_get_capabilities_result, NULL};
static const GDBusMethodInfo _dock_manager_dbus_method_info_get_capabilities = {-1, "GetCapabilities", (GDBusArgInfo **) (&_dock_manager_dbus_arg_info_get_capabilities_in), (GDBusArgInfo **) (&_dock_manager_dbus_arg_info_get_capabilities_out)};
static const GDBusArgInfo _dock_manager_dbus_arg_info_awn_set_visibility_win_class = {-1, "win_class", "s"};
static const GDBusArgInfo _dock_manager_dbus_arg_info_awn_set_visibility_visible = {-1, "visible", "b"};
static const GDBusArgInfo * const _dock_manager_dbus_arg_info_awn_set_visibility_in[] = {&_dock_manager_dbus_arg_info_awn_set_visibility_win_class, &_dock_manager_dbus_arg_info_awn_set_visibility_visible, NULL};
static const GDBusArgInfo * const _dock_manager_dbus_arg_info_awn_set_visibility_out[] = {NULL};
static const GDBusMethodInfo _dock_manager_dbus_method_info_awn_set_visibility = {-1, "AwnSetVisibility", (GDBusArgInfo **) (&_dock_manager_dbus_arg_info_awn_set_visibility_in), (GDBusArgInfo **) (&_dock_manager_dbus_arg_info_awn_set_visibility_out)};
static const GDBusMethodInfo * const _dock_manager_dbus_method_info[] = {&_dock_manager_dbus_method_info_get_capabilities, &_dock_manager_dbus_method_info_awn_set_visibility, NULL};
static const GDBusSignalInfo * const _dock_manager_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _dock_manager_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _dock_manager_dbus_interface_info = {-1, "net.launchpad.DockManager", (GDBusMethodInfo **) (&_dock_manager_dbus_method_info), (GDBusSignalInfo **) (&_dock_manager_dbus_signal_info), (GDBusPropertyInfo **) (&_dock_manager_dbus_property_info)};
static const GDBusInterfaceVTable _dock_manager_dbus_interface_vtable = {dock_manager_dbus_interface_method_call, dock_manager_dbus_interface_get_property, dock_manager_dbus_interface_set_property};
static const GtkTargetEntry PREFS_APPLET_targets[1] = {{"awn/awn-panel", (guint) GTK_TARGET_SAME_WIDGET, (guint) 0}};

void dock_manager_get_capabilities (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DOCK_MANAGER_GET_INTERFACE (self)->get_capabilities (self, _callback_, _user_data_);
}


gchar** dock_manager_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error) {
	return DOCK_MANAGER_GET_INTERFACE (self)->get_capabilities_finish (self, _res_, result_length1, error);
}


void dock_manager_awn_set_visibility (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	DOCK_MANAGER_GET_INTERFACE (self)->awn_set_visibility (self, win_class, visible, _callback_, _user_data_);
}


void dock_manager_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error) {
	DOCK_MANAGER_GET_INTERFACE (self)->awn_set_visibility_finish (self, _res_, error);
}


static void dock_manager_base_init (DockManagerIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
	}
}


GType dock_manager_get_type (void) {
	static volatile gsize dock_manager_type_id__volatile = 0;
	if (g_once_init_enter (&dock_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DockManagerIface), (GBaseInitFunc) dock_manager_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType dock_manager_type_id;
		dock_manager_type_id = g_type_register_static (G_TYPE_INTERFACE, "DockManager", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (dock_manager_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (dock_manager_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) dock_manager_proxy_get_type);
		g_type_set_qdata (dock_manager_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "net.launchpad.DockManager");
		g_type_set_qdata (dock_manager_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) dock_manager_register_object);
		g_once_init_leave (&dock_manager_type_id__volatile, dock_manager_type_id);
	}
	return dock_manager_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (DockManagerProxy, dock_manager_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_DOCK_MANAGER, dock_manager_proxy_dock_manager_interface_init) )
static void dock_manager_proxy_class_init (DockManagerProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = dock_manager_proxy_g_signal;
}


static void dock_manager_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
}


static void dock_manager_proxy_init (DockManagerProxy* self) {
}


static void _vala_g_async_ready_callback (GObject *source_object, GAsyncResult *res, void *user_data) {
	g_simple_async_result_set_op_res_gpointer (user_data, g_object_ref (res), g_object_unref);
	g_simple_async_result_complete (user_data);
	g_object_unref (user_data);
}


static void dock_manager_proxy_get_capabilities_async (DockManager* self, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	DBUS_GERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "net.launchpad.DockManager", "GetCapabilities");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static gchar** dock_manager_proxy_get_capabilities_finish (DockManager* self, GAsyncResult* _res_, int* result_length1, GError** error) {
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar** _result;
	int _result_length1;
	GVariant* _tmp0_;
	gchar** _tmp1_;
	int _tmp1__length;
	int _tmp1__size;
	int _tmp1__length1;
	GVariantIter _tmp2_;
	GVariant* _tmp3_;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_result_length1 = 0;
	_tmp0_ = g_variant_iter_next_value (&_reply_iter);
	_tmp1_ = g_new (gchar*, 5);
	_tmp1__length = 0;
	_tmp1__size = 4;
	_tmp1__length1 = 0;
	g_variant_iter_init (&_tmp2_, _tmp0_);
	for (; (_tmp3_ = g_variant_iter_next_value (&_tmp2_)) != NULL; _tmp1__length1++) {
		if (_tmp1__size == _tmp1__length) {
			_tmp1__size = 2 * _tmp1__size;
			_tmp1_ = g_renew (gchar*, _tmp1_, _tmp1__size + 1);
		}
		_tmp1_[_tmp1__length++] = g_variant_dup_string (_tmp3_, NULL);
		g_variant_unref (_tmp3_);
	}
	_result_length1 = _tmp1__length1;
	_tmp1_[_tmp1__length] = NULL;
	_result = _tmp1_;
	g_variant_unref (_tmp0_);
	*result_length1 = _result_length1;
	g_object_unref (_reply_message);
	return _result;
}


static void dock_manager_proxy_awn_set_visibility_async (DockManager* self, const gchar* win_class, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	DBUS_GERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "net.launchpad.DockManager", "AwnSetVisibility");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (win_class));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_boolean (visible));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	g_dbus_connection_send_message_with_reply (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, _vala_g_async_ready_callback, g_simple_async_result_new ((GObject *) self, _callback_, _user_data_, NULL));
	g_object_unref (_message);
}


static void dock_manager_proxy_awn_set_visibility_finish (DockManager* self, GAsyncResult* _res_, GError** error) {
	GDBusMessage *_reply_message;
	_reply_message = g_dbus_connection_send_message_with_reply_finish (g_dbus_proxy_get_connection ((GDBusProxy *) self), g_simple_async_result_get_op_res_gpointer ((GSimpleAsyncResult *) _res_), error);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void dock_manager_proxy_dock_manager_interface_init (DockManagerIface* iface) {
	iface->get_capabilities = dock_manager_proxy_get_capabilities_async;
	iface->get_capabilities_finish = dock_manager_proxy_get_capabilities_finish;
	iface->awn_set_visibility = dock_manager_proxy_awn_set_visibility_async;
	iface->awn_set_visibility_finish = dock_manager_proxy_awn_set_visibility_finish;
}


static void _dbus_dock_manager_get_capabilities (DockManager* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	dock_manager_get_capabilities (self, (GAsyncReadyCallback) _dbus_dock_manager_get_capabilities_ready, invocation);
}


static void _dbus_dock_manager_get_capabilities_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** result;
	int result_length1 = 0;
	gchar** _tmp4_;
	GVariantBuilder _tmp5_;
	int _tmp6_;
	invocation = _user_data_;
	result = dock_manager_get_capabilities_finish ((DockManager*) source_object, _res_, &result_length1, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_tmp4_ = result;
	g_variant_builder_init (&_tmp5_, G_VARIANT_TYPE ("as"));
	for (_tmp6_ = 0; _tmp6_ < result_length1; _tmp6_++) {
		g_variant_builder_add_value (&_tmp5_, g_variant_new_string (*_tmp4_));
		_tmp4_++;
	}
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp5_));
	result = (_vala_array_free (result, result_length1, (GDestroyNotify) g_free), NULL);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_dock_manager_awn_set_visibility (DockManager* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GVariantIter _arguments_iter;
	gchar* win_class = NULL;
	GVariant* _tmp7_;
	gboolean visible = FALSE;
	GVariant* _tmp8_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp7_ = g_variant_iter_next_value (&_arguments_iter);
	win_class = g_variant_dup_string (_tmp7_, NULL);
	g_variant_unref (_tmp7_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	visible = g_variant_get_boolean (_tmp8_);
	g_variant_unref (_tmp8_);
	dock_manager_awn_set_visibility (self, win_class, visible, (GAsyncReadyCallback) _dbus_dock_manager_awn_set_visibility_ready, invocation);
	_g_free0 (win_class);
}


static void _dbus_dock_manager_awn_set_visibility_ready (GObject * source_object, GAsyncResult * _res_, gpointer _user_data_) {
	GDBusMethodInvocation * invocation;
	GError* error = NULL;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	invocation = _user_data_;
	dock_manager_awn_set_visibility_finish ((DockManager*) source_object, _res_, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void dock_manager_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "GetCapabilities") == 0) {
		_dbus_dock_manager_get_capabilities (object, parameters, invocation);
	} else if (strcmp (method_name, "AwnSetVisibility") == 0) {
		_dbus_dock_manager_awn_set_visibility (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* dock_manager_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean dock_manager_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


guint dock_manager_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_dock_manager_dbus_interface_info), &_dock_manager_dbus_interface_vtable, data, _dock_manager_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}


static void _dock_manager_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


PrefsApplet* prefs_applet_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id) {
	PrefsApplet * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	self = (PrefsApplet*) g_object_new (object_type, "canonical-name", _tmp0_, "uid", _tmp1_, "panel-id", _tmp2_, NULL);
	return self;
}


PrefsApplet* prefs_applet_new (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	return prefs_applet_construct (TYPE_PREFS_APPLET, canonical_name, uid, panel_id);
}


static void _prefs_applet_on_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	prefs_applet_on_clicked (self);
}


static void _prefs_applet_on_context_menu_popup_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self) {
	prefs_applet_on_context_menu_popup (self, event);
}


static void _prefs_applet_on_drag_begin_gtk_widget_drag_begin (GtkWidget* _sender, GdkDragContext* context, gpointer self) {
	prefs_applet_on_drag_begin (self, context);
}


static void _prefs_applet_on_drag_end_gtk_widget_drag_end (GtkWidget* _sender, GdkDragContext* context, gpointer self) {
	prefs_applet_on_drag_end (self, context);
}


static gboolean _prefs_applet_on_drag_failed_gtk_widget_drag_failed (GtkWidget* _sender, GdkDragContext* p0, GtkDragResult p1, gpointer self) {
	gboolean result;
	result = prefs_applet_on_drag_failed (self, p0, p1);
	return result;
}


static void _prefs_applet_taskmanager_appeared_awn_dbus_watcher_name_appeared (AwnDBusWatcher* _sender, const gchar* name, gpointer self) {
	prefs_applet_taskmanager_appeared (self, name);
}


static void __lambda12_ (PrefsApplet* self, AwnApplet* w) {
	g_return_if_fail (w != NULL);
	prefs_applet_update_taskmanager (self, TRUE, NULL, NULL);
}


static void ___lambda12__awn_applet_applet_deleted (AwnApplet* _sender, gpointer self) {
	__lambda12_ (self, _sender);
}


static void prefs_applet_real_constructed (GObject* base) {
	PrefsApplet * self;
	gint _tmp0_ = 0;
	gint _tmp1_;
	DesktopAgnosticConfigClient* _tmp2_ = NULL;
	DesktopAgnosticConfigClient* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar** _tmp8_ = NULL;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar** _tmp14_ = NULL;
	gchar** _tmp15_;
	gint _tmp15__length1;
	AwnIcon* _tmp16_ = NULL;
	AwnIcon* icon;
	AwnIcon* _tmp17_;
	AwnIcon* _tmp18_;
	AwnIcon* _tmp19_;
	AwnIcon* _tmp20_;
	AwnIcon* _tmp21_;
	AwnIcon* _tmp22_;
	GdkPixbuf* _tmp23_;
	GdkPixbuf* pixbuf;
	GdkPixbuf* _tmp24_;
	AwnIcon* _tmp25_;
	GdkPixbuf* _tmp26_;
	AwnDBusWatcher* _tmp27_ = NULL;
	AwnDBusWatcher* watcher;
	AwnDBusWatcher* _tmp28_;
	GError * _inner_error_ = NULL;
	self = (PrefsApplet*) base;
	G_OBJECT_CLASS (prefs_applet_parent_class)->constructed ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, AWN_TYPE_APPLET_SIMPLE, AwnAppletSimple));
	g_object_get ((AwnApplet*) self, "panel-id", &_tmp0_, NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = awn_config_get_default (_tmp1_, &_inner_error_);
	_tmp3_ = _tmp2_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	self->priv->panel_client = _tmp3_;
	_tmp4_ = g_strdup ("main-icon");
	_tmp5_ = g_strdup ("dir");
	_tmp6_ = g_strdup ("prefs");
	_tmp7_ = g_strdup ("about");
	_tmp8_ = g_new0 (gchar*, 4 + 1);
	_tmp8_[0] = _tmp4_;
	_tmp8_[1] = _tmp5_;
	_tmp8_[2] = _tmp6_;
	_tmp8_[3] = _tmp7_;
	_tmp9_ = _tmp8_;
	_tmp9__length1 = 4;
	_tmp10_ = g_strdup ("awn-settings");
	_tmp11_ = g_strdup ("gtk-directory");
	_tmp12_ = g_strdup ("gtk-preferences");
	_tmp13_ = g_strdup ("gtk-about");
	_tmp14_ = g_new0 (gchar*, 4 + 1);
	_tmp14_[0] = _tmp10_;
	_tmp14_[1] = _tmp11_;
	_tmp14_[2] = _tmp12_;
	_tmp14_[3] = _tmp13_;
	_tmp15_ = _tmp14_;
	_tmp15__length1 = 4;
	awn_applet_simple_set_icon_info ((AwnAppletSimple*) self, _tmp9_, _tmp15_);
	_tmp15_ = (_vala_array_free (_tmp15_, _tmp15__length1, (GDestroyNotify) g_free), NULL);
	_tmp9_ = (_vala_array_free (_tmp9_, _tmp9__length1, (GDestroyNotify) g_free), NULL);
	awn_applet_simple_set_icon_state ((AwnAppletSimple*) self, "main-icon");
	_tmp16_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	icon = _tmp16_;
	_tmp17_ = icon;
	g_signal_connect_object (_tmp17_, "clicked", (GCallback) _prefs_applet_on_clicked_awn_icon_clicked, self, 0);
	_tmp18_ = icon;
	g_signal_connect_object (_tmp18_, "context-menu-popup", (GCallback) _prefs_applet_on_context_menu_popup_awn_icon_context_menu_popup, self, 0);
	_tmp19_ = icon;
	g_signal_connect_object ((GtkWidget*) _tmp19_, "drag-begin", (GCallback) _prefs_applet_on_drag_begin_gtk_widget_drag_begin, self, 0);
	_tmp20_ = icon;
	g_signal_connect_object ((GtkWidget*) _tmp20_, "drag-end", (GCallback) _prefs_applet_on_drag_end_gtk_widget_drag_end, self, 0);
	_tmp21_ = icon;
	g_signal_connect_object ((GtkWidget*) _tmp21_, "drag-failed", (GCallback) _prefs_applet_on_drag_failed_gtk_widget_drag_failed, self, 0);
	_tmp22_ = icon;
	gtk_drag_source_set ((GtkWidget*) _tmp22_, GDK_BUTTON1_MASK, PREFS_APPLET_targets, G_N_ELEMENTS (PREFS_APPLET_targets), GDK_ACTION_LINK);
	_tmp23_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, 1, 1);
	pixbuf = _tmp23_;
	_tmp24_ = pixbuf;
	gdk_pixbuf_fill (_tmp24_, (guint32) 0);
	_tmp25_ = icon;
	_tmp26_ = pixbuf;
	gtk_drag_source_set_icon_pixbuf ((GtkWidget*) _tmp25_, _tmp26_);
	awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, "Avant Window Navigator");
	prefs_applet_initialize_menu (self);
	_tmp27_ = awn_dbus_watcher_get_default ();
	watcher = _tmp27_;
	_tmp28_ = watcher;
	g_signal_connect_object (_tmp28_, "name-appeared::net.launchpad.DockManager", (GCallback) _prefs_applet_taskmanager_appeared_awn_dbus_watcher_name_appeared, self, 0);
	prefs_applet_update_taskmanager (self, FALSE, NULL, NULL);
	g_signal_connect_object ((AwnApplet*) self, "applet-deleted", (GCallback) ___lambda12__awn_applet_applet_deleted, self, 0);
	_g_object_unref0 (pixbuf);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _prefs_applet_on_quit_click_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	prefs_applet_on_quit_click (self);
}


static void __lambda11_ (PrefsApplet* self, GtkMenuItem* w) {
	g_return_if_fail (w != NULL);
	prefs_applet_run_preferences (self, TRUE);
}


static void ___lambda11__gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	__lambda11_ (self, _sender);
}


static void prefs_applet_initialize_menu (PrefsApplet* self) {
	GtkWidget* _tmp0_ = NULL;
	GtkMenu* _tmp1_;
	GtkImageMenuItem* _tmp2_;
	GtkImageMenuItem* quit_item;
	GtkMenu* _tmp3_;
	const gchar* _tmp4_ = NULL;
	GtkImageMenuItem* _tmp5_;
	GtkImageMenuItem* about_item;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkMenu* _tmp8_;
	GtkMenu* _tmp9_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_create_default_menu ((AwnApplet*) self);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_MENU) ? ((GtkMenu*) _tmp0_) : NULL);
	_g_object_unref0 (self->priv->ctx_menu);
	self->priv->ctx_menu = _tmp1_;
	_tmp2_ = (GtkImageMenuItem*) gtk_image_menu_item_new_from_stock (GTK_STOCK_QUIT, NULL);
	g_object_ref_sink (_tmp2_);
	quit_item = _tmp2_;
	g_signal_connect_object ((GtkMenuItem*) quit_item, "activate", (GCallback) _prefs_applet_on_quit_click_gtk_menu_item_activate, self, 0);
	gtk_widget_show ((GtkWidget*) quit_item);
	_tmp3_ = self->priv->ctx_menu;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp3_, (GtkWidget*) ((GtkMenuItem*) quit_item));
	_tmp4_ = _ ("About Awn");
	_tmp5_ = (GtkImageMenuItem*) gtk_image_menu_item_new_with_label (_tmp4_);
	g_object_ref_sink (_tmp5_);
	about_item = _tmp5_;
	_tmp6_ = (GtkImage*) gtk_image_new_from_stock (GTK_STOCK_ABOUT, GTK_ICON_SIZE_MENU);
	g_object_ref_sink (_tmp6_);
	_tmp7_ = _tmp6_;
	gtk_image_menu_item_set_image (about_item, (GtkWidget*) _tmp7_);
	_g_object_unref0 (_tmp7_);
	g_signal_connect_object ((GtkMenuItem*) about_item, "activate", (GCallback) ___lambda11__gtk_menu_item_activate, self, 0);
	gtk_widget_show ((GtkWidget*) about_item);
	_tmp8_ = self->priv->ctx_menu;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, (GtkWidget*) ((GtkMenuItem*) about_item));
	_tmp9_ = self->priv->ctx_menu;
	awn_utils_show_menu_images (_tmp9_);
	_g_object_unref0 (about_item);
	_g_object_unref0 (quit_item);
}


static void prefs_applet_taskmanager_appeared (PrefsApplet* self, const gchar* name) {
	g_return_if_fail (self != NULL);
	g_return_if_fail (name != NULL);
	prefs_applet_update_taskmanager (self, FALSE, NULL, NULL);
}


static void prefs_applet_update_taskmanager_data_free (gpointer _data) {
	PrefsAppletUpdateTaskmanagerData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (PrefsAppletUpdateTaskmanagerData, _data_);
}


static void prefs_applet_update_taskmanager (PrefsApplet* self, gboolean visible, GAsyncReadyCallback _callback_, gpointer _user_data_) {
	PrefsAppletUpdateTaskmanagerData* _data_;
	PrefsApplet* _tmp0_;
	gboolean _tmp1_;
	_data_ = g_slice_new0 (PrefsAppletUpdateTaskmanagerData);
	_data_->_async_result = g_simple_async_result_new (G_OBJECT (self), _callback_, _user_data_, prefs_applet_update_taskmanager);
	g_simple_async_result_set_op_res_gpointer (_data_->_async_result, _data_, prefs_applet_update_taskmanager_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = visible;
	_data_->visible = _tmp1_;
	prefs_applet_update_taskmanager_co (_data_);
}


static void prefs_applet_update_taskmanager_finish (PrefsApplet* self, GAsyncResult* _res_) {
	PrefsAppletUpdateTaskmanagerData* _data_;
	_data_ = g_simple_async_result_get_op_res_gpointer (G_SIMPLE_ASYNC_RESULT (_res_));
}


static void prefs_applet_update_taskmanager_ready (GObject* source_object, GAsyncResult* _res_, gpointer _user_data_) {
	PrefsAppletUpdateTaskmanagerData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	prefs_applet_update_taskmanager_co (_data_);
}


static gboolean prefs_applet_update_taskmanager_co (PrefsAppletUpdateTaskmanagerData* _data_) {
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	{
		_data_->_tmp0_ = NULL;
		_data_->_tmp0_ = dbus_g_bus_get (DBUS_BUS_SESSION, &_data_->_inner_error_);
		_data_->con = _data_->_tmp0_;
		if (_data_->_inner_error_ != NULL) {
			if (_data_->_inner_error_->domain == DBUS_GERROR) {
				goto __catch0_dbus_gerror;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
		_data_->_tmp1_ = _data_->con;
		_data_->_tmp2_ = NULL;
		_data_->_tmp2_ = dbus_g_proxy_new_for_name (_data_->_tmp1_, "net.launchpad.DockManager", "/net/launchpad/DockManager", "net.launchpad.DockManager");
		_data_->taskman = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp2_, TYPE_DOCK_MANAGER, DockManager);
		_data_->_tmp3_ = _data_->taskman;
		_data_->_tmp4_ = 0;
		_data_->_state_ = 1;
		dock_manager_get_capabilities (_data_->_tmp3_, prefs_applet_update_taskmanager_ready, _data_);
		return FALSE;
		_state_1:
		_data_->_tmp5_ = NULL;
		_data_->_tmp5_ = dock_manager_get_capabilities_finish (_data_->_tmp3_, _data_->_res_, &_data_->_tmp4_, &_data_->_inner_error_);
		_data_->caps = _data_->_tmp5_;
		_data_->caps_length1 = _data_->_tmp4_;
		_data_->_caps_size_ = _data_->caps_length1;
		if (_data_->_inner_error_ != NULL) {
			_g_object_unref0 (_data_->taskman);
			_dbus_g_connection_unref0 (_data_->con);
			if (_data_->_inner_error_->domain == DBUS_GERROR) {
				goto __catch0_dbus_gerror;
			}
			_g_object_unref0 (_data_->taskman);
			_dbus_g_connection_unref0 (_data_->con);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
			g_clear_error (&_data_->_inner_error_);
			return FALSE;
		}
		_data_->supports_visibility_setting = FALSE;
		_data_->_tmp6_ = _data_->caps;
		_data_->_tmp6__length1 = _data_->caps_length1;
		{
			_data_->cap_collection_length1 = 0;
			_data_->_cap_collection_size_ = 0;
			_data_->cap_collection = _data_->_tmp6_;
			_data_->cap_collection_length1 = _data_->_tmp6__length1;
			for (_data_->cap_it = 0; _data_->cap_it < _data_->_tmp6__length1; _data_->cap_it = _data_->cap_it + 1) {
				_data_->_tmp7_ = g_strdup (_data_->cap_collection[_data_->cap_it]);
				_data_->cap = _data_->_tmp7_;
				{
					_data_->_tmp8_ = _data_->cap;
					if (g_strcmp0 (_data_->_tmp8_, "x-awn-set-visibility") == 0) {
						_data_->supports_visibility_setting = TRUE;
					}
					_g_free0 (_data_->cap);
				}
			}
		}
		_data_->_tmp9_ = _data_->supports_visibility_setting;
		if (_data_->_tmp9_) {
			_data_->_tmp10_ = _data_->taskman;
			_data_->_tmp11_ = _data_->visible;
			dock_manager_awn_set_visibility (_data_->_tmp10_, "awn-settings", _data_->_tmp11_, NULL, NULL);
		}
		_data_->caps = (_vala_array_free (_data_->caps, _data_->caps_length1, (GDestroyNotify) g_free), NULL);
		_g_object_unref0 (_data_->taskman);
		_dbus_g_connection_unref0 (_data_->con);
	}
	goto __finally0;
	__catch0_dbus_gerror:
	{
		_data_->err = _data_->_inner_error_;
		_data_->_inner_error_ = NULL;
		_g_error_free0 (_data_->err);
	}
	__finally0:
	if (_data_->_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
		g_clear_error (&_data_->_inner_error_);
		return FALSE;
	}
	if (_data_->_state_ == 0) {
		g_simple_async_result_complete_in_idle (_data_->_async_result);
	} else {
		g_simple_async_result_complete (_data_->_async_result);
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}


static void prefs_applet_on_active_changed (PrefsApplet* self, WnckWindow* old_active) {
	AwnIcon* _tmp0_ = NULL;
	AwnIcon* icon;
	GList* _tmp1_;
	AwnIcon* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	icon = _tmp0_;
	_tmp1_ = self->priv->windows;
	{
		GList* window_collection = NULL;
		GList* window_it = NULL;
		window_collection = _tmp1_;
		for (window_it = window_collection; window_it != NULL; window_it = window_it->next) {
			WnckWindow* window = NULL;
			window = (WnckWindow*) window_it->data;
			{
				WnckWindow* _tmp2_;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = window;
				_tmp3_ = wnck_window_is_active (_tmp2_);
				if (_tmp3_) {
					AwnIcon* _tmp4_;
					_tmp4_ = icon;
					awn_icon_set_is_active (_tmp4_, TRUE);
					return;
				}
			}
		}
	}
	_tmp5_ = icon;
	awn_icon_set_is_active (_tmp5_, FALSE);
}


static void prefs_applet_on_window_opened (PrefsApplet* self, WnckWindow* window) {
	WnckWindow* _tmp0_;
	WnckClassGroup* _tmp1_ = NULL;
	const gchar* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = window;
	_tmp1_ = wnck_window_get_class_group (_tmp0_);
	_tmp2_ = wnck_class_group_get_name (_tmp1_);
	if (g_strcmp0 (_tmp2_, "awn-settings") == 0) {
		WnckWindow* _tmp3_;
		_tmp3_ = window;
		self->priv->windows = g_list_append (self->priv->windows, _tmp3_);
	}
	prefs_applet_update_icon (self);
}


static void prefs_applet_on_window_closed (PrefsApplet* self, WnckWindow* window) {
	GList* _tmp0_;
	WnckWindow* _tmp1_;
	GList* _tmp2_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (window != NULL);
	_tmp0_ = self->priv->windows;
	_tmp1_ = window;
	_tmp2_ = g_list_find (_tmp0_, _tmp1_);
	if (_tmp2_ != NULL) {
		WnckWindow* _tmp3_;
		_tmp3_ = window;
		self->priv->windows = g_list_remove (self->priv->windows, _tmp3_);
	}
	prefs_applet_update_icon (self);
}


static void prefs_applet_update_icon (PrefsApplet* self) {
	AwnIcon* _tmp0_ = NULL;
	AwnIcon* icon;
	GList* _tmp1_;
	guint _tmp2_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	icon = _tmp0_;
	_tmp1_ = self->priv->windows;
	_tmp2_ = g_list_length (_tmp1_);
	awn_icon_set_indicator_count (icon, (gint) _tmp2_);
}


static gboolean prefs_applet_on_timer_tick (PrefsApplet* self) {
	gboolean result = FALSE;
	gint mouse_x = 0;
	gint mouse_y = 0;
	GdkScreen* screen = NULL;
	GdkRectangle rect = {0};
	AwnIcon* _tmp0_ = NULL;
	GdkDisplay* _tmp1_ = NULL;
	GdkScreen* _tmp2_ = NULL;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	GdkScreen* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint _tmp8_ = 0;
	gint monitor_num;
	GdkScreen* _tmp9_;
	gint _tmp10_ = 0;
	gint n_monitors;
	GdkScreen* _tmp11_;
	gint _tmp12_ = 0;
	gint default_mon;
	GdkScreen* _tmp13_;
	gint _tmp14_;
	GdkRectangle _tmp15_ = {0};
	gint _tmp16_;
	GdkRectangle _tmp17_;
	gint _tmp18_;
	GdkRectangle _tmp19_;
	gint _tmp20_;
	gfloat rel_x;
	gint _tmp21_;
	GdkRectangle _tmp22_;
	gint _tmp23_;
	GdkRectangle _tmp24_;
	gint _tmp25_;
	gfloat rel_y;
	GtkPositionType pos = 0;
	gboolean _tmp26_ = FALSE;
	gfloat _tmp27_;
	gboolean _tmp29_;
	gboolean is_top;
	gboolean _tmp30_ = FALSE;
	gfloat _tmp31_;
	gboolean _tmp33_;
	gboolean is_bottom;
	gboolean _tmp34_ = FALSE;
	gfloat _tmp35_;
	gboolean _tmp37_;
	gboolean is_left;
	gboolean _tmp38_ = FALSE;
	gfloat _tmp39_;
	gboolean _tmp41_;
	gboolean is_right;
	gboolean _tmp42_ = FALSE;
	gboolean _tmp43_ = FALSE;
	gboolean _tmp44_ = FALSE;
	gboolean _tmp45_;
	gboolean _tmp47_;
	gboolean _tmp49_;
	gboolean _tmp51_;
	gboolean on_edge;
	gboolean _tmp52_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp1_ = gtk_widget_get_display ((GtkWidget*) _tmp0_);
	gdk_display_get_pointer (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, NULL);
	screen = _tmp2_;
	mouse_x = _tmp3_;
	mouse_y = _tmp4_;
	_tmp5_ = screen;
	_tmp6_ = mouse_x;
	_tmp7_ = mouse_y;
	_tmp8_ = gdk_screen_get_monitor_at_point (_tmp5_, _tmp6_, _tmp7_);
	monitor_num = _tmp8_;
	_tmp9_ = screen;
	_tmp10_ = gdk_screen_get_n_monitors (_tmp9_);
	n_monitors = _tmp10_;
	_tmp11_ = screen;
	_tmp12_ = gdk_screen_get_monitor_at_point (_tmp11_, 0, 0);
	default_mon = _tmp12_;
	_tmp13_ = screen;
	_tmp14_ = monitor_num;
	gdk_screen_get_monitor_geometry (_tmp13_, _tmp14_, &_tmp15_);
	rect = _tmp15_;
	_tmp16_ = mouse_x;
	_tmp17_ = rect;
	_tmp18_ = _tmp17_.x;
	_tmp19_ = rect;
	_tmp20_ = _tmp19_.width;
	rel_x = (_tmp16_ - _tmp18_) / ((gfloat) _tmp20_);
	_tmp21_ = mouse_y;
	_tmp22_ = rect;
	_tmp23_ = _tmp22_.y;
	_tmp24_ = rect;
	_tmp25_ = _tmp24_.height;
	rel_y = (_tmp21_ - _tmp23_) / ((gfloat) _tmp25_);
	_tmp27_ = rel_y;
	if (((gdouble) _tmp27_) <= 0.15) {
		gfloat _tmp28_;
		_tmp28_ = rel_y;
		_tmp26_ = _tmp28_ >= ((gfloat) 0);
	} else {
		_tmp26_ = FALSE;
	}
	_tmp29_ = _tmp26_;
	is_top = _tmp29_;
	_tmp31_ = rel_y;
	if (((gdouble) _tmp31_) >= 0.85) {
		gfloat _tmp32_;
		_tmp32_ = rel_y;
		_tmp30_ = _tmp32_ <= ((gfloat) 1);
	} else {
		_tmp30_ = FALSE;
	}
	_tmp33_ = _tmp30_;
	is_bottom = _tmp33_;
	_tmp35_ = rel_x;
	if (((gdouble) _tmp35_) <= 0.15) {
		gfloat _tmp36_;
		_tmp36_ = rel_x;
		_tmp34_ = _tmp36_ >= ((gfloat) 0);
	} else {
		_tmp34_ = FALSE;
	}
	_tmp37_ = _tmp34_;
	is_left = _tmp37_;
	_tmp39_ = rel_x;
	if (((gdouble) _tmp39_) >= 0.85) {
		gfloat _tmp40_;
		_tmp40_ = rel_x;
		_tmp38_ = _tmp40_ <= ((gfloat) 1);
	} else {
		_tmp38_ = FALSE;
	}
	_tmp41_ = _tmp38_;
	is_right = _tmp41_;
	_tmp45_ = is_top;
	if (_tmp45_) {
		_tmp44_ = TRUE;
	} else {
		gboolean _tmp46_;
		_tmp46_ = is_bottom;
		_tmp44_ = _tmp46_;
	}
	_tmp47_ = _tmp44_;
	if (_tmp47_) {
		_tmp43_ = TRUE;
	} else {
		gboolean _tmp48_;
		_tmp48_ = is_left;
		_tmp43_ = _tmp48_;
	}
	_tmp49_ = _tmp43_;
	if (_tmp49_) {
		_tmp42_ = TRUE;
	} else {
		gboolean _tmp50_;
		_tmp50_ = is_right;
		_tmp42_ = _tmp50_;
	}
	_tmp51_ = _tmp42_;
	on_edge = _tmp51_;
	_tmp52_ = is_bottom;
	if (_tmp52_) {
		pos = GTK_POS_BOTTOM;
	} else {
		gboolean _tmp53_;
		_tmp53_ = is_top;
		if (_tmp53_) {
			pos = GTK_POS_TOP;
		} else {
			gboolean _tmp54_;
			_tmp54_ = is_left;
			if (_tmp54_) {
				pos = GTK_POS_LEFT;
			} else {
				gboolean _tmp55_;
				_tmp55_ = is_right;
				if (_tmp55_) {
					pos = GTK_POS_RIGHT;
				} else {
					pos = GTK_POS_BOTTOM;
				}
			}
		}
	}
	{
		DesktopAgnosticConfigClient* _tmp56_;
		gint _tmp57_;
		gboolean _tmp68_;
		_tmp56_ = self->priv->panel_client;
		desktop_agnostic_config_client_set_bool (_tmp56_, "panel", "monitor_force", FALSE, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_tmp57_ = n_monitors;
		if (_tmp57_ > 1) {
			DesktopAgnosticConfigClient* _tmp58_;
			gint _tmp59_ = 0;
			gint config_mon;
			gboolean _tmp60_ = FALSE;
			gint _tmp61_;
			gint _tmp62_;
			gboolean _tmp65_;
			_tmp58_ = self->priv->panel_client;
			_tmp59_ = desktop_agnostic_config_client_get_int (_tmp58_, "panel", "monitor_num", &_inner_error_);
			config_mon = _tmp59_;
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
			}
			_tmp61_ = default_mon;
			_tmp62_ = monitor_num;
			if (_tmp61_ != _tmp62_) {
				_tmp60_ = TRUE;
			} else {
				gint _tmp63_;
				gint _tmp64_;
				_tmp63_ = monitor_num;
				_tmp64_ = config_mon;
				_tmp60_ = _tmp63_ != _tmp64_;
			}
			_tmp65_ = _tmp60_;
			if (_tmp65_) {
				DesktopAgnosticConfigClient* _tmp66_;
				gint _tmp67_;
				_tmp66_ = self->priv->panel_client;
				_tmp67_ = monitor_num;
				desktop_agnostic_config_client_set_int (_tmp66_, "panel", "monitor_num", _tmp67_, &_inner_error_);
				if (_inner_error_ != NULL) {
					goto __catch1_g_error;
				}
			}
		}
		_tmp68_ = on_edge;
		if (_tmp68_) {
			DesktopAgnosticConfigClient* _tmp69_;
			GtkPositionType _tmp70_;
			_tmp69_ = self->priv->panel_client;
			_tmp70_ = pos;
			desktop_agnostic_config_client_set_int (_tmp69_, "panel", "orient", (gint) _tmp70_, &_inner_error_);
			if (_inner_error_ != NULL) {
				goto __catch1_g_error;
			}
		}
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* e = NULL;
		GError* _tmp71_;
		const gchar* _tmp72_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp71_ = e;
		_tmp72_ = _tmp71_->message;
		g_warning ("applet.vala:273: Unable to set panel properties. Error: %s", _tmp72_);
		_g_error_free0 (e);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = TRUE;
	return result;
}


static gboolean _prefs_applet_on_timer_tick_gsource_func (gpointer self) {
	gboolean result;
	result = prefs_applet_on_timer_tick (self);
	return result;
}


static void prefs_applet_on_drag_begin (PrefsApplet* self, GdkDragContext* context) {
	const gchar* _tmp0_ = NULL;
	AwnIcon* _tmp1_ = NULL;
	AwnTooltip* _tmp2_ = NULL;
	AwnTooltip* tooltip;
	AwnTooltip* _tmp3_;
	AwnTooltip* _tmp4_;
	AwnTooltip* _tmp5_;
	guint _tmp6_;
	guint _tmp8_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	self->priv->in_drag = TRUE;
	_tmp0_ = _ ("Drag to change panel orientation");
	awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, _tmp0_);
	_tmp1_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp2_ = awn_icon_get_tooltip (_tmp1_);
	tooltip = _tmp2_;
	_tmp3_ = tooltip;
	g_object_set (_tmp3_, "smart-behavior", FALSE, NULL);
	_tmp4_ = tooltip;
	g_object_set (_tmp4_, "toggle-on-click", FALSE, NULL);
	_tmp5_ = tooltip;
	gtk_widget_show ((GtkWidget*) _tmp5_);
	_tmp6_ = self->priv->timer_id;
	if (_tmp6_ == ((guint) 0)) {
		guint _tmp7_ = 0U;
		_tmp7_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 300, _prefs_applet_on_timer_tick_gsource_func, g_object_ref (self), g_object_unref);
		self->priv->timer_id = _tmp7_;
	}
	_tmp8_ = self->priv->autohide_cookie;
	if (_tmp8_ == ((guint) 0)) {
		guint _tmp9_ = 0U;
		_tmp9_ = awn_applet_inhibit_autohide ((AwnApplet*) self, "awn-settings");
		self->priv->autohide_cookie = _tmp9_;
	}
}


static void prefs_applet_on_drag_end (PrefsApplet* self, GdkDragContext* context) {
	guint _tmp0_;
	guint _tmp2_;
	AwnIcon* _tmp4_ = NULL;
	AwnTooltip* _tmp5_ = NULL;
	AwnTooltip* tooltip;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	_tmp0_ = self->priv->timer_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->timer_id;
		g_source_remove (_tmp1_);
		self->priv->timer_id = (guint) 0;
	}
	_tmp2_ = self->priv->autohide_cookie;
	if (_tmp2_ != ((guint) 0)) {
		guint _tmp3_;
		_tmp3_ = self->priv->autohide_cookie;
		awn_applet_uninhibit_autohide ((AwnApplet*) self, _tmp3_);
		self->priv->autohide_cookie = (guint) 0;
	}
	_tmp4_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp5_ = awn_icon_get_tooltip (_tmp4_);
	tooltip = _tmp5_;
	gtk_widget_hide ((GtkWidget*) tooltip);
	awn_applet_simple_set_tooltip_text ((AwnAppletSimple*) self, "Avant Window Navigator");
	g_object_set (tooltip, "smart-behavior", TRUE, NULL);
	g_object_set (tooltip, "toggle-on-click", TRUE, NULL);
	self->priv->in_drag = FALSE;
}


static gboolean prefs_applet_on_drag_failed (PrefsApplet* self, GdkDragContext* context, GtkDragResult _result_) {
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (context != NULL, FALSE);
	result = TRUE;
	return result;
}


static void prefs_applet_on_clicked (PrefsApplet* self) {
	gboolean _tmp0_;
	guint32 _tmp1_ = 0U;
	guint32 cur_time;
	GList* _tmp2_;
	guint _tmp3_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->in_drag;
	if (_tmp0_) {
		return;
	}
	_tmp1_ = gtk_get_current_event_time ();
	cur_time = _tmp1_;
	_tmp2_ = self->priv->windows;
	_tmp3_ = g_list_length (_tmp2_);
	if (_tmp3_ >= ((guint) 1)) {
		GList* _tmp4_;
		gconstpointer _tmp5_;
		WnckWindow* window;
		WnckWindow* _tmp6_;
		gboolean _tmp7_ = FALSE;
		_tmp4_ = self->priv->windows;
		_tmp5_ = _tmp4_->data;
		window = (WnckWindow*) _tmp5_;
		_tmp6_ = window;
		_tmp7_ = wnck_window_is_active (_tmp6_);
		if (_tmp7_) {
			GList* _tmp8_;
			_tmp8_ = self->priv->windows;
			{
				GList* w_collection = NULL;
				GList* w_it = NULL;
				w_collection = _tmp8_;
				for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
					WnckWindow* w = NULL;
					w = (WnckWindow*) w_it->data;
					{
						WnckWindow* _tmp9_;
						_tmp9_ = w;
						wnck_window_minimize (_tmp9_);
					}
				}
			}
		} else {
			WnckWindow* _tmp10_;
			guint32 _tmp11_;
			_tmp10_ = window;
			_tmp11_ = cur_time;
			wnck_window_activate (_tmp10_, _tmp11_);
		}
	} else {
		GdkNativeWindow _tmp12_ = {0};
		GdkNativeWindow window_id;
		GdkNativeWindow _tmp13_;
		_tmp12_ = awn_applet_docklet_request ((AwnApplet*) self, 450, FALSE, TRUE);
		window_id = _tmp12_;
		_tmp13_ = window_id;
		if (((glong) _tmp13_) != ((glong) 0)) {
			GdkNativeWindow _tmp14_;
			_tmp14_ = window_id;
			prefs_applet_setup_docklet (self, _tmp14_);
		} else {
			GtkMenu* _tmp15_;
			guint32 _tmp16_;
			_tmp15_ = self->priv->ctx_menu;
			_tmp16_ = cur_time;
			gtk_menu_popup (_tmp15_, NULL, NULL, NULL, NULL, (guint) 0, _tmp16_);
		}
	}
}


void prefs_applet_setup_label_for_docklet (AwnLabel* label, AwnApplet* docklet) {
	AwnApplet* _tmp0_;
	GtkPositionType _tmp1_ = 0;
	GtkPositionType pos_type;
	gboolean _tmp2_ = FALSE;
	GtkPositionType _tmp3_;
	gboolean _tmp5_;
	g_return_if_fail (label != NULL);
	g_return_if_fail (docklet != NULL);
	_tmp0_ = docklet;
	_tmp1_ = awn_applet_get_pos_type (_tmp0_);
	pos_type = _tmp1_;
	_tmp3_ = pos_type;
	if (_tmp3_ == GTK_POS_TOP) {
		_tmp2_ = TRUE;
	} else {
		GtkPositionType _tmp4_;
		_tmp4_ = pos_type;
		_tmp2_ = _tmp4_ == GTK_POS_BOTTOM;
	}
	_tmp5_ = _tmp2_;
	if (_tmp5_) {
		AwnLabel* _tmp6_;
		AwnApplet* _tmp7_;
		gint _tmp8_ = 0;
		AwnLabel* _tmp9_;
		AwnLabel* _tmp10_;
		_tmp6_ = label;
		_tmp7_ = docklet;
		_tmp8_ = awn_applet_get_size (_tmp7_);
		gtk_widget_set_size_request ((GtkWidget*) _tmp6_, -1, _tmp8_);
		_tmp9_ = label;
		gtk_misc_set_alignment ((GtkMisc*) _tmp9_, 1.0f, 0.5f);
		_tmp10_ = label;
		gtk_label_set_angle ((GtkLabel*) _tmp10_, (gdouble) 0);
	} else {
		AwnLabel* _tmp11_;
		AwnApplet* _tmp12_;
		gint _tmp13_ = 0;
		AwnLabel* _tmp14_;
		gint _tmp15_ = 0;
		GtkPositionType _tmp16_;
		AwnLabel* _tmp17_;
		gint _tmp18_;
		_tmp11_ = label;
		_tmp12_ = docklet;
		_tmp13_ = awn_applet_get_size (_tmp12_);
		gtk_widget_set_size_request ((GtkWidget*) _tmp11_, _tmp13_, -1);
		_tmp14_ = label;
		gtk_misc_set_alignment ((GtkMisc*) _tmp14_, 0.5f, 1.0f);
		_tmp16_ = pos_type;
		if (_tmp16_ == GTK_POS_LEFT) {
			_tmp15_ = 90;
		} else {
			_tmp15_ = 270;
		}
		_tmp17_ = label;
		_tmp18_ = _tmp15_;
		gtk_label_set_angle ((GtkLabel*) _tmp17_, (gdouble) _tmp18_);
	}
}


static AwnIcon* prefs_applet_new_unbound_icon (void) {
	AwnIcon* result = NULL;
	AwnIcon* icon = NULL;
	GObject* _tmp0_ = NULL;
	GObject* _tmp1_;
	GObject* _tmp2_;
	GObject* _tmp3_ = NULL;
	GObject* _tmp4_;
	GObject* _tmp5_ = NULL;
	AwnIcon* _tmp6_;
	_tmp0_ = g_object_new (AWN_TYPE_ICON, "bind-effects", FALSE, NULL);
	_tmp1_ = G_IS_INITIALLY_UNOWNED (_tmp0_) ? g_object_ref_sink (_tmp0_) : _tmp0_;
	_tmp2_ = _tmp1_;
	_tmp3_ = g_object_ref_sink (_tmp2_);
	_tmp4_ = _tmp3_;
	_tmp5_ = g_object_ref (_tmp4_);
	_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp5_, AWN_TYPE_ICON) ? ((AwnIcon*) _tmp5_) : NULL);
	_g_object_unref0 (icon);
	icon = _tmp6_;
	_g_object_unref0 (_tmp4_);
	_g_object_unref0 (_tmp2_);
	result = icon;
	return result;
}


static void __lambda2_ (PrefsApplet* self, GtkObject* w) {
	g_return_if_fail (w != NULL);
	_g_object_unref0 (self->priv->docklet);
	self->priv->docklet = NULL;
	_g_list_free0 (self->priv->docklet_icons);
	self->priv->docklet_icons = NULL;
}


static void ___lambda2__gtk_object_destroy (GtkObject* _sender, gpointer self) {
	__lambda2_ (self, _sender);
}


static void __lambda3_ (PrefsApplet* self, AwnApplet* w, gint s) {
	const gchar* icon_name = NULL;
	AwnIcon* _tmp0_ = NULL;
	AwnThemedIcon* loader;
	GList* _tmp1_;
	g_return_if_fail (w != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	loader = G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, AWN_TYPE_THEMED_ICON) ? ((AwnThemedIcon*) _tmp0_) : NULL;
	_tmp1_ = self->priv->docklet_icons;
	{
		GList* widget_collection = NULL;
		GList* widget_it = NULL;
		widget_collection = _tmp1_;
		for (widget_it = widget_collection; widget_it != NULL; widget_it = widget_it->next) {
			GtkWidget* widget = NULL;
			widget = (GtkWidget*) widget_it->data;
			{
				GtkWidget* _tmp2_;
				gconstpointer _tmp3_ = NULL;
				void* ptr;
				void* _tmp4_;
				const gchar* _tmp5_;
				_tmp2_ = widget;
				_tmp3_ = g_object_get_data ((GObject*) _tmp2_, "icon-name");
				ptr = _tmp3_;
				_tmp4_ = ptr;
				icon_name = (const gchar*) _tmp4_;
				_tmp5_ = icon_name;
				if (_tmp5_ != NULL) {
					GtkWidget* _tmp6_;
					AwnIcon* it_icon;
					AwnIcon* _tmp7_;
					AwnThemedIcon* _tmp8_;
					gint _tmp9_;
					const gchar* _tmp10_;
					GdkPixbuf* _tmp11_ = NULL;
					GdkPixbuf* _tmp12_;
					_tmp6_ = widget;
					it_icon = G_TYPE_CHECK_INSTANCE_TYPE (_tmp6_, AWN_TYPE_ICON) ? ((AwnIcon*) _tmp6_) : NULL;
					_tmp7_ = it_icon;
					_tmp8_ = loader;
					_tmp9_ = s;
					_tmp10_ = icon_name;
					_tmp11_ = awn_themed_icon_get_icon_at_size (_tmp8_, _tmp9_, _tmp10_);
					_tmp12_ = _tmp11_;
					awn_icon_set_from_pixbuf (_tmp7_, _tmp12_);
					_g_object_unref0 (_tmp12_);
				} else {
					GtkWidget* _tmp13_;
					AwnApplet* _tmp14_;
					_tmp13_ = widget;
					_tmp14_ = w;
					prefs_applet_setup_label_for_docklet (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, AWN_TYPE_LABEL) ? ((AwnLabel*) _tmp13_) : NULL, _tmp14_);
				}
			}
		}
	}
}


static void ___lambda3__awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self) {
	__lambda3_ (self, _sender, size);
}


static void __lambda4_ (PrefsApplet* self, AwnApplet* w, GtkPositionType p) {
	AwnApplet* _tmp0_;
	GtkWidget* _tmp1_ = NULL;
	AwnBox* box;
	AwnBox* _tmp2_;
	GtkPositionType _tmp3_;
	GList* _tmp4_;
	g_return_if_fail (w != NULL);
	_tmp0_ = w;
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
	box = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, AWN_TYPE_BOX) ? ((AwnBox*) _tmp1_) : NULL;
	_tmp2_ = box;
	_tmp3_ = p;
	awn_box_set_orientation_from_pos_type (_tmp2_, _tmp3_);
	_tmp4_ = self->priv->docklet_icons;
	{
		GList* widget_collection = NULL;
		GList* widget_it = NULL;
		widget_collection = _tmp4_;
		for (widget_it = widget_collection; widget_it != NULL; widget_it = widget_it->next) {
			GtkWidget* widget = NULL;
			widget = (GtkWidget*) widget_it->data;
			{
				GtkWidget* _tmp5_;
				GType _tmp6_ = 0UL;
				_tmp5_ = widget;
				_tmp6_ = G_TYPE_FROM_INSTANCE ((GObject*) _tmp5_);
				if (_tmp6_ == AWN_TYPE_LABEL) {
					GtkWidget* _tmp7_;
					AwnApplet* _tmp8_;
					_tmp7_ = widget;
					_tmp8_ = w;
					prefs_applet_setup_label_for_docklet (G_TYPE_CHECK_INSTANCE_TYPE (_tmp7_, AWN_TYPE_LABEL) ? ((AwnLabel*) _tmp7_) : NULL, _tmp8_);
				}
			}
		}
	}
}


static void ___lambda4__awn_applet_position_changed (AwnApplet* _sender, GtkPositionType position, gpointer self) {
	__lambda4_ (self, _sender, position);
}


static void __lambda5_ (PrefsApplet* self, AwnIcon* w) {
	AwnApplet* _tmp0_;
	g_return_if_fail (w != NULL);
	_tmp0_ = self->priv->docklet;
	gtk_object_destroy ((GtkObject*) _tmp0_);
}


static void ___lambda5__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	__lambda5_ (self, _sender);
}


static void __lambda6_ (PrefsApplet* self, AwnIcon* w) {
	g_return_if_fail (w != NULL);
	prefs_applet_change_icon_size (self, 32);
}


static void ___lambda6__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	__lambda6_ (self, _sender);
}


static void __lambda7_ (PrefsApplet* self, AwnIcon* w) {
	g_return_if_fail (w != NULL);
	prefs_applet_change_icon_size (self, 40);
}


static void ___lambda7__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	__lambda7_ (self, _sender);
}


static void __lambda8_ (PrefsApplet* self, AwnIcon* w) {
	g_return_if_fail (w != NULL);
	prefs_applet_change_icon_size (self, 48);
}


static void ___lambda8__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	__lambda8_ (self, _sender);
}


static void __lambda9_ (PrefsApplet* self, AwnIcon* w) {
	AwnApplet* _tmp0_;
	g_return_if_fail (w != NULL);
	prefs_applet_run_preferences (self, FALSE);
	_tmp0_ = self->priv->docklet;
	gtk_object_destroy ((GtkObject*) _tmp0_);
}


static void ___lambda9__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	__lambda9_ (self, _sender);
}


static void __lambda10_ (PrefsApplet* self, AwnIcon* w) {
	AwnApplet* _tmp0_;
	g_return_if_fail (w != NULL);
	prefs_applet_run_preferences (self, TRUE);
	_tmp0_ = self->priv->docklet;
	gtk_object_destroy ((GtkObject*) _tmp0_);
}


static void ___lambda10__awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	__lambda10_ (self, _sender);
}


void prefs_applet_setup_docklet (PrefsApplet* self, GdkNativeWindow window_id) {
	AwnIcon* icon = NULL;
	AwnLabel* label = NULL;
	AwnAlignment* align = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gint icon_size;
	gint _tmp2_ = 0;
	gint _tmp3_;
	AwnApplet* _tmp4_;
	AwnApplet* _tmp5_;
	AwnApplet* _tmp6_;
	AwnApplet* _tmp7_;
	AwnApplet* _tmp8_;
	AwnBox* _tmp9_;
	AwnBox* main_box;
	AwnApplet* _tmp10_;
	GtkPositionType _tmp11_ = 0;
	AwnApplet* _tmp12_;
	AwnIcon* _tmp13_ = NULL;
	AwnThemedIcon* icon_loader;
	AwnApplet* _tmp14_;
	AwnIconBox* _tmp15_;
	AwnIconBox* box;
	AwnIconBox* _tmp16_;
	AwnIcon* _tmp17_ = NULL;
	AwnIcon* _tmp18_;
	AwnIcon* _tmp19_;
	GdkPixbuf* _tmp20_ = NULL;
	GdkPixbuf* _tmp21_;
	AwnIcon* _tmp22_;
	const gchar* _tmp23_ = NULL;
	AwnIcon* _tmp24_;
	AwnIcon* _tmp25_;
	AwnIcon* _tmp26_;
	AwnIcon* _tmp27_;
	AwnIcon* _tmp28_;
	GdkPixbuf* _tmp29_;
	GdkPixbuf* pixbuf;
	AwnIcon* _tmp30_;
	AwnIcon* _tmp31_;
	AwnIconBox* _tmp32_;
	AwnIcon* _tmp33_;
	AwnApplet* _tmp34_;
	AwnAlignment* _tmp35_;
	AwnLabel* _tmp36_;
	AwnLabel* _tmp37_;
	const gchar* _tmp38_ = NULL;
	AwnLabel* _tmp39_;
	AwnApplet* _tmp40_;
	AwnLabel* _tmp41_;
	AwnLabel* _tmp42_;
	AwnApplet* _tmp43_;
	AwnIconBox* _tmp44_;
	AwnIconBox* _tmp45_;
	AwnIcon* _tmp46_ = NULL;
	AwnIcon* _tmp47_;
	GdkPixbuf* _tmp48_ = NULL;
	GdkPixbuf* _tmp49_;
	AwnIcon* _tmp50_;
	AwnIconBox* _tmp51_;
	AwnIcon* _tmp52_;
	AwnIcon* _tmp53_ = NULL;
	AwnIcon* _tmp54_;
	GdkPixbuf* _tmp55_ = NULL;
	GdkPixbuf* _tmp56_;
	AwnIcon* _tmp57_;
	AwnIconBox* _tmp58_;
	AwnIcon* _tmp59_;
	AwnIcon* _tmp60_ = NULL;
	AwnIcon* _tmp61_;
	GdkPixbuf* _tmp62_ = NULL;
	GdkPixbuf* _tmp63_;
	AwnIcon* _tmp64_;
	AwnIconBox* _tmp65_;
	AwnIcon* _tmp66_;
	AwnLabel* _tmp67_;
	AwnLabel* _tmp68_;
	AwnApplet* _tmp69_;
	AwnIconBox* _tmp70_;
	AwnIconBox* _tmp71_;
	AwnIcon* _tmp72_ = NULL;
	AwnIcon* _tmp73_;
	AwnIcon* _tmp74_;
	GdkPixbuf* _tmp75_ = NULL;
	GdkPixbuf* _tmp76_;
	AwnIcon* _tmp77_;
	const gchar* _tmp78_ = NULL;
	AwnIcon* _tmp79_;
	AwnIcon* _tmp80_;
	AwnIconBox* _tmp81_;
	AwnIcon* _tmp82_;
	AwnIcon* _tmp83_ = NULL;
	AwnIcon* _tmp84_;
	AwnIcon* _tmp85_;
	GdkPixbuf* _tmp86_ = NULL;
	GdkPixbuf* _tmp87_;
	AwnIcon* _tmp88_;
	const gchar* _tmp89_ = NULL;
	AwnIcon* _tmp90_;
	AwnIcon* _tmp91_;
	AwnIconBox* _tmp92_;
	AwnIcon* _tmp93_;
	AwnApplet* _tmp94_;
	GdkNativeWindow _tmp95_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_get_size ((AwnApplet*) self);
	_tmp1_ = _tmp0_;
	icon_size = _tmp1_;
	_g_list_free0 (self->priv->docklet_icons);
	self->priv->docklet_icons = NULL;
	g_object_get ((AwnApplet*) self, "panel-id", &_tmp2_, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = awn_applet_new ("quick-prefs", "docklet", _tmp3_);
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->docklet);
	self->priv->docklet = _tmp4_;
	_tmp5_ = self->priv->docklet;
	g_object_set (_tmp5_, "quit-on-delete", FALSE, NULL);
	awn_applet_set_behavior ((AwnApplet*) self, AWN_APPLET_DOCKLET_HANDLES_POSITION_CHANGE);
	_tmp6_ = self->priv->docklet;
	g_signal_connect_object ((GtkObject*) _tmp6_, "destroy", (GCallback) ___lambda2__gtk_object_destroy, self, 0);
	_tmp7_ = self->priv->docklet;
	g_signal_connect_object (_tmp7_, "size-changed", (GCallback) ___lambda3__awn_applet_size_changed, self, 0);
	_tmp8_ = self->priv->docklet;
	g_signal_connect_object (_tmp8_, "position-changed", (GCallback) ___lambda4__awn_applet_position_changed, self, 0);
	_tmp9_ = (AwnBox*) awn_box_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp9_);
	main_box = _tmp9_;
	_tmp10_ = self->priv->docklet;
	_tmp11_ = awn_applet_get_pos_type (_tmp10_);
	awn_box_set_orientation_from_pos_type (main_box, _tmp11_);
	_tmp12_ = self->priv->docklet;
	gtk_container_add ((GtkContainer*) _tmp12_, (GtkWidget*) main_box);
	_tmp13_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	icon_loader = G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, AWN_TYPE_THEMED_ICON) ? ((AwnThemedIcon*) _tmp13_) : NULL;
	_tmp14_ = self->priv->docklet;
	_tmp15_ = (AwnIconBox*) awn_icon_box_new_for_applet (_tmp14_);
	g_object_ref_sink (_tmp15_);
	box = _tmp15_;
	_tmp16_ = box;
	gtk_container_add ((GtkContainer*) main_box, (GtkWidget*) _tmp16_);
	_tmp17_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp17_;
	_tmp18_ = icon;
	g_object_set_data_full ((GObject*) _tmp18_, "icon-name", (void*) "main-icon", NULL);
	_tmp19_ = icon;
	_tmp20_ = awn_themed_icon_get_icon_at_size (icon_loader, icon_size, "main-icon");
	_tmp21_ = _tmp20_;
	awn_icon_set_from_pixbuf (_tmp19_, _tmp21_);
	_g_object_unref0 (_tmp21_);
	_tmp22_ = icon;
	_tmp23_ = _ ("Drag to change panel orientation");
	awn_icon_set_tooltip_text (_tmp22_, _tmp23_);
	_tmp24_ = icon;
	g_signal_connect_object (_tmp24_, "clicked", (GCallback) ___lambda5__awn_icon_clicked, self, 0);
	_tmp25_ = icon;
	g_signal_connect_object ((GtkWidget*) _tmp25_, "drag-begin", (GCallback) _prefs_applet_on_drag_begin_gtk_widget_drag_begin, self, 0);
	_tmp26_ = icon;
	g_signal_connect_object ((GtkWidget*) _tmp26_, "drag-end", (GCallback) _prefs_applet_on_drag_end_gtk_widget_drag_end, self, 0);
	_tmp27_ = icon;
	g_signal_connect_object ((GtkWidget*) _tmp27_, "drag-failed", (GCallback) _prefs_applet_on_drag_failed_gtk_widget_drag_failed, self, 0);
	_tmp28_ = icon;
	gtk_drag_source_set ((GtkWidget*) _tmp28_, GDK_BUTTON1_MASK, PREFS_APPLET_targets, G_N_ELEMENTS (PREFS_APPLET_targets), GDK_ACTION_LINK);
	_tmp29_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, 1, 1);
	pixbuf = _tmp29_;
	gdk_pixbuf_fill (pixbuf, (guint32) 0);
	_tmp30_ = icon;
	gtk_drag_source_set_icon_pixbuf ((GtkWidget*) _tmp30_, pixbuf);
	_tmp31_ = icon;
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) _tmp31_);
	_tmp32_ = box;
	_tmp33_ = icon;
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
	_tmp34_ = self->priv->docklet;
	_tmp35_ = (AwnAlignment*) awn_alignment_new_for_applet (_tmp34_);
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (align);
	align = _tmp35_;
	_tmp36_ = awn_label_new ();
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (label);
	label = _tmp36_;
	_tmp37_ = label;
	_tmp38_ = _ ("Icon size:");
	gtk_label_set_text ((GtkLabel*) _tmp37_, _tmp38_);
	_tmp39_ = label;
	_tmp40_ = self->priv->docklet;
	prefs_applet_setup_label_for_docklet (_tmp39_, _tmp40_);
	_tmp41_ = label;
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) _tmp41_);
	_tmp42_ = label;
	gtk_container_add ((GtkContainer*) align, (GtkWidget*) _tmp42_);
	gtk_box_pack_start ((GtkBox*) main_box, (GtkWidget*) align, TRUE, TRUE, (guint) 6);
	_tmp43_ = self->priv->docklet;
	_tmp44_ = (AwnIconBox*) awn_icon_box_new_for_applet (_tmp43_);
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (box);
	box = _tmp44_;
	_tmp45_ = box;
	gtk_box_pack_start ((GtkBox*) main_box, (GtkWidget*) _tmp45_, FALSE, FALSE, (guint) 0);
	_tmp46_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp46_;
	_tmp47_ = icon;
	_tmp48_ = awn_themed_icon_get_icon_at_size (icon_loader, 32, "dir");
	_tmp49_ = _tmp48_;
	awn_icon_set_from_pixbuf (_tmp47_, _tmp49_);
	_g_object_unref0 (_tmp49_);
	_tmp50_ = icon;
	g_signal_connect_object (_tmp50_, "clicked", (GCallback) ___lambda6__awn_icon_clicked, self, 0);
	_tmp51_ = box;
	_tmp52_ = icon;
	gtk_container_add ((GtkContainer*) _tmp51_, (GtkWidget*) _tmp52_);
	_tmp53_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp53_;
	_tmp54_ = icon;
	_tmp55_ = awn_themed_icon_get_icon_at_size (icon_loader, 40, "dir");
	_tmp56_ = _tmp55_;
	awn_icon_set_from_pixbuf (_tmp54_, _tmp56_);
	_g_object_unref0 (_tmp56_);
	_tmp57_ = icon;
	g_signal_connect_object (_tmp57_, "clicked", (GCallback) ___lambda7__awn_icon_clicked, self, 0);
	_tmp58_ = box;
	_tmp59_ = icon;
	gtk_container_add ((GtkContainer*) _tmp58_, (GtkWidget*) _tmp59_);
	_tmp60_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp60_;
	_tmp61_ = icon;
	_tmp62_ = awn_themed_icon_get_icon_at_size (icon_loader, 48, "dir");
	_tmp63_ = _tmp62_;
	awn_icon_set_from_pixbuf (_tmp61_, _tmp63_);
	_g_object_unref0 (_tmp63_);
	_tmp64_ = icon;
	g_signal_connect_object (_tmp64_, "clicked", (GCallback) ___lambda8__awn_icon_clicked, self, 0);
	_tmp65_ = box;
	_tmp66_ = icon;
	gtk_container_add ((GtkContainer*) _tmp65_, (GtkWidget*) _tmp66_);
	_tmp67_ = awn_label_new ();
	g_object_ref_sink (_tmp67_);
	_g_object_unref0 (label);
	label = _tmp67_;
	_tmp68_ = label;
	gtk_box_pack_start ((GtkBox*) main_box, (GtkWidget*) _tmp68_, TRUE, FALSE, (guint) 0);
	_tmp69_ = self->priv->docklet;
	_tmp70_ = (AwnIconBox*) awn_icon_box_new_for_applet (_tmp69_);
	g_object_ref_sink (_tmp70_);
	_g_object_unref0 (box);
	box = _tmp70_;
	_tmp71_ = box;
	gtk_container_add ((GtkContainer*) main_box, (GtkWidget*) _tmp71_);
	_tmp72_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp72_;
	_tmp73_ = icon;
	g_object_set_data_full ((GObject*) _tmp73_, "icon-name", (void*) "prefs", NULL);
	_tmp74_ = icon;
	_tmp75_ = awn_themed_icon_get_icon_at_size (icon_loader, icon_size, "prefs");
	_tmp76_ = _tmp75_;
	awn_icon_set_from_pixbuf (_tmp74_, _tmp76_);
	_g_object_unref0 (_tmp76_);
	_tmp77_ = icon;
	_tmp78_ = _ ("Dock Preferences");
	awn_icon_set_tooltip_text (_tmp77_, _tmp78_);
	_tmp79_ = icon;
	g_signal_connect_object (_tmp79_, "clicked", (GCallback) ___lambda9__awn_icon_clicked, self, 0);
	_tmp80_ = icon;
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) _tmp80_);
	_tmp81_ = box;
	_tmp82_ = icon;
	gtk_container_add ((GtkContainer*) _tmp81_, (GtkWidget*) _tmp82_);
	_tmp83_ = prefs_applet_new_unbound_icon ();
	_g_object_unref0 (icon);
	icon = _tmp83_;
	_tmp84_ = icon;
	g_object_set_data_full ((GObject*) _tmp84_, "icon-name", (void*) "about", NULL);
	_tmp85_ = icon;
	_tmp86_ = awn_themed_icon_get_icon_at_size (icon_loader, icon_size, "about");
	_tmp87_ = _tmp86_;
	awn_icon_set_from_pixbuf (_tmp85_, _tmp87_);
	_g_object_unref0 (_tmp87_);
	_tmp88_ = icon;
	_tmp89_ = _ ("About Awn");
	awn_icon_set_tooltip_text (_tmp88_, _tmp89_);
	_tmp90_ = icon;
	g_signal_connect_object (_tmp90_, "clicked", (GCallback) ___lambda10__awn_icon_clicked, self, 0);
	_tmp91_ = icon;
	self->priv->docklet_icons = g_list_append (self->priv->docklet_icons, (GtkWidget*) _tmp91_);
	_tmp92_ = box;
	_tmp93_ = icon;
	gtk_container_add ((GtkContainer*) _tmp92_, (GtkWidget*) _tmp93_);
	_tmp94_ = self->priv->docklet;
	_tmp95_ = window_id;
	gtk_plug_construct (G_TYPE_CHECK_INSTANCE_TYPE (_tmp94_, GTK_TYPE_PLUG) ? ((GtkPlug*) _tmp94_) : NULL, _tmp95_);
	_g_object_unref0 (pixbuf);
	_g_object_unref0 (box);
	_g_object_unref0 (main_box);
	_g_object_unref0 (align);
	_g_object_unref0 (label);
	_g_object_unref0 (icon);
}


static void prefs_applet_change_icon_size (PrefsApplet* self, gint new_size) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		DesktopAgnosticConfigClient* _tmp0_;
		gint _tmp1_;
		_tmp0_ = self->priv->panel_client;
		_tmp1_ = new_size;
		desktop_agnostic_config_client_set_int (_tmp0_, "panel", "size", _tmp1_, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch2_g_error;
		}
	}
	goto __finally2;
	__catch2_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp2_ = e;
		_tmp3_ = _tmp2_->message;
		g_warning ("applet.vala:547: Unable to set panel properties. Error: %s", _tmp3_);
		_g_error_free0 (e);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void prefs_applet_run_preferences (PrefsApplet* self, gboolean about_only) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		gchar** argv = NULL;
		gint argv_length1 = 0;
		gint _argv_size_ = 0;
		gboolean _tmp0_;
		GdkScreen* _tmp9_ = NULL;
		gchar** _tmp10_;
		gint _tmp10__length1;
		_tmp0_ = about_only;
		if (_tmp0_) {
			gchar* _tmp1_;
			gchar* _tmp2_;
			gchar** _tmp3_ = NULL;
			_tmp1_ = g_strdup ("awn-settings");
			_tmp2_ = g_strdup ("--about");
			_tmp3_ = g_new0 (gchar*, 2 + 1);
			_tmp3_[0] = _tmp1_;
			_tmp3_[1] = _tmp2_;
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
			argv = _tmp3_;
			argv_length1 = 2;
			_argv_size_ = argv_length1;
		} else {
			gchar* _tmp4_;
			gint _tmp5_ = 0;
			gint _tmp6_;
			gchar* _tmp7_ = NULL;
			gchar** _tmp8_ = NULL;
			_tmp4_ = g_strdup ("awn-settings");
			g_object_get ((AwnApplet*) self, "panel-id", &_tmp5_, NULL);
			_tmp6_ = _tmp5_;
			_tmp7_ = g_strdup_printf ("--panel-id=%d", _tmp6_);
			_tmp8_ = g_new0 (gchar*, 2 + 1);
			_tmp8_[0] = _tmp4_;
			_tmp8_[1] = _tmp7_;
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
			argv = _tmp8_;
			argv_length1 = 2;
			_argv_size_ = argv_length1;
		}
		_tmp9_ = gtk_window_get_screen ((GtkWindow*) self);
		_tmp10_ = argv;
		_tmp10__length1 = argv_length1;
		gdk_spawn_on_screen (_tmp9_, NULL, _tmp10_, NULL, G_SPAWN_SEARCH_PATH, NULL, NULL, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
			goto __catch3_g_error;
		}
		argv = (_vala_array_free (argv, argv_length1, (GDestroyNotify) g_free), NULL);
	}
	goto __finally3;
	__catch3_g_error:
	{
		GError* err = NULL;
		gchar* msg = NULL;
		const gchar* _tmp11_ = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
		gchar* _tmp14_ = NULL;
		const gchar* _tmp15_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp11_ = _ ("Could not open Awn settings: %s");
		_tmp12_ = err;
		_tmp13_ = _tmp12_->message;
		_tmp14_ = g_strdup_printf (_tmp11_, _tmp13_);
		_g_free0 (msg);
		msg = _tmp14_;
		_tmp15_ = msg;
		g_warning ("applet.vala:579: %s", _tmp15_);
		_g_free0 (msg);
		_g_error_free0 (err);
	}
	__finally3:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void prefs_applet_on_quit_click (PrefsApplet* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		DBusGConnection* _tmp0_ = NULL;
		DBusGConnection* con;
		DBusGProxy* awn = NULL;
		DBusGProxy* _tmp1_ = NULL;
		GError* err = NULL;
		gint _tmp2_ = 0;
		gint _tmp3_;
		GError* _tmp4_ = NULL;
		_tmp0_ = dbus_g_bus_get (DBUS_BUS_SESSION, &_inner_error_);
		con = _tmp0_;
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DBUS_GERROR) {
				goto __catch4_dbus_gerror;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp1_ = dbus_g_proxy_new_for_name (con, "org.awnproject.Awn", "/org/awnproject/Awn", "org.awnproject.Awn.App");
		_g_object_unref0 (awn);
		awn = _tmp1_;
		g_object_get ((AwnApplet*) self, "panel-id", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		dbus_g_proxy_call (awn, "RemovePanel", &_tmp4_, (GType) _tmp3_, NULL);
		_g_error_free0 (err);
		err = _tmp4_;
		_g_error_free0 (err);
		_g_object_unref0 (awn);
		_dbus_g_connection_unref0 (con);
	}
	goto __finally4;
	__catch4_dbus_gerror:
	{
		GError* err = NULL;
		const gchar* _tmp5_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = err->message;
		g_error ("applet.vala:600: %s", _tmp5_);
		_g_error_free0 (err);
	}
	__finally4:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static void prefs_applet_on_context_menu_popup (PrefsApplet* self, GdkEventButton* evt) {
	AwnIcon* _tmp0_ = NULL;
	GtkMenu* _tmp1_;
	GdkEventButton _tmp2_;
	guint _tmp3_;
	GdkEventButton _tmp4_;
	guint32 _tmp5_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (evt != NULL);
	_tmp0_ = awn_applet_simple_get_icon ((AwnAppletSimple*) self);
	_tmp1_ = self->priv->ctx_menu;
	_tmp2_ = *evt;
	_tmp3_ = _tmp2_.button;
	_tmp4_ = *evt;
	_tmp5_ = _tmp4_.time;
	awn_icon_popup_gtk_menu (_tmp0_, (GtkWidget*) _tmp1_, _tmp3_, _tmp5_);
}


static void _prefs_applet_on_window_opened_wnck_screen_window_opened (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	prefs_applet_on_window_opened (self, window);
}


static void _prefs_applet_on_window_closed_wnck_screen_window_closed (WnckScreen* _sender, WnckWindow* window, gpointer self) {
	prefs_applet_on_window_closed (self, window);
}


static void _prefs_applet_on_active_changed_wnck_screen_active_window_changed (WnckScreen* _sender, WnckWindow* previous_window, gpointer self) {
	prefs_applet_on_active_changed (self, previous_window);
}


static GObject * prefs_applet_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	PrefsApplet * self;
	WnckScreen* _tmp0_ = NULL;
	WnckScreen* wnck_screen;
	WnckScreen* _tmp1_;
	WnckScreen* _tmp2_;
	WnckScreen* _tmp3_;
	parent_class = G_OBJECT_CLASS (prefs_applet_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFS_APPLET, PrefsApplet);
	_tmp0_ = wnck_screen_get_default ();
	wnck_screen = _tmp0_;
	wnck_set_client_type (WNCK_CLIENT_TYPE_PAGER);
	_tmp1_ = wnck_screen;
	g_signal_connect_object (_tmp1_, "window-opened", (GCallback) _prefs_applet_on_window_opened_wnck_screen_window_opened, self, 0);
	_tmp2_ = wnck_screen;
	g_signal_connect_object (_tmp2_, "window-closed", (GCallback) _prefs_applet_on_window_closed_wnck_screen_window_closed, self, 0);
	_tmp3_ = wnck_screen;
	g_signal_connect_object (_tmp3_, "active-window-changed", (GCallback) _prefs_applet_on_active_changed_wnck_screen_active_window_changed, self, 0);
	_g_list_free0 (self->priv->windows);
	self->priv->windows = NULL;
	return obj;
}


static void prefs_applet_class_init (PrefsAppletClass * klass) {
	prefs_applet_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (PrefsAppletPrivate));
	G_OBJECT_CLASS (klass)->constructed = prefs_applet_real_constructed;
	G_OBJECT_CLASS (klass)->constructor = prefs_applet_constructor;
	G_OBJECT_CLASS (klass)->finalize = prefs_applet_finalize;
}


static void prefs_applet_instance_init (PrefsApplet * self) {
	self->priv = PREFS_APPLET_GET_PRIVATE (self);
	self->priv->panel_client = NULL;
	self->priv->ctx_menu = NULL;
	self->priv->timer_id = (guint) 0;
	self->priv->in_drag = FALSE;
	self->priv->autohide_cookie = (guint) 0;
}


static void prefs_applet_finalize (GObject* obj) {
	PrefsApplet * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PREFS_APPLET, PrefsApplet);
	_g_object_unref0 (self->priv->ctx_menu);
	_g_list_free0 (self->priv->windows);
	_g_object_unref0 (self->priv->docklet);
	_g_list_free0 (self->priv->docklet_icons);
	G_OBJECT_CLASS (prefs_applet_parent_class)->finalize (obj);
}


GType prefs_applet_get_type (void) {
	static volatile gsize prefs_applet_type_id__volatile = 0;
	if (g_once_init_enter (&prefs_applet_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PrefsAppletClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) prefs_applet_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PrefsApplet), 0, (GInstanceInitFunc) prefs_applet_instance_init, NULL };
		GType prefs_applet_type_id;
		prefs_applet_type_id = g_type_register_static (AWN_TYPE_APPLET_SIMPLE, "PrefsApplet", &g_define_type_info, 0);
		g_once_init_leave (&prefs_applet_type_id__volatile, prefs_applet_type_id);
	}
	return prefs_applet_type_id__volatile;
}


AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	AwnApplet* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	PrefsApplet* _tmp3_;
	AwnApplet* applet;
	WnckScreen* _tmp4_ = NULL;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	textdomain (GETTEXT_PACKAGE);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	_tmp3_ = prefs_applet_new (_tmp0_, _tmp1_, _tmp2_);
	g_object_ref_sink (_tmp3_);
	applet = (AwnApplet*) _tmp3_;
	_tmp4_ = wnck_screen_get_default ();
	wnck_screen_force_update (_tmp4_);
	result = applet;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



