/* simple-launcher.c generated by valac 0.20.1, the Vala compiler
 * generated from simple-launcher.vala, do not modify */

/*
 * Copyright (C) 2010 Michal Hruby <michal.mhr@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301  USA.
 *
 * Author : Michal Hruby <michal.mhr@gmail.com>
 */

#include <glib.h>
#include <glib-object.h>
#include "libawn/libawn.h"
#include <gtk/gtk.h>
#include <libdesktop-agnostic/config.h>
#include <stdlib.h>
#include <string.h>
#include <config.h>
#include <gdk/gdk.h>
#include <libdesktop-agnostic/vfs.h>
#include <libdesktop-agnostic/fdo.h>
#include <libdesktop-agnostic/ui.h>
#include <glib/gstdio.h>


#define TYPE_SIMPLE_LAUNCHER (simple_launcher_get_type ())
#define SIMPLE_LAUNCHER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SIMPLE_LAUNCHER, SimpleLauncher))
#define SIMPLE_LAUNCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SIMPLE_LAUNCHER, SimpleLauncherClass))
#define IS_SIMPLE_LAUNCHER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SIMPLE_LAUNCHER))
#define IS_SIMPLE_LAUNCHER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SIMPLE_LAUNCHER))
#define SIMPLE_LAUNCHER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SIMPLE_LAUNCHER, SimpleLauncherClass))

typedef struct _SimpleLauncher SimpleLauncher;
typedef struct _SimpleLauncherClass SimpleLauncherClass;
typedef struct _SimpleLauncherPrivate SimpleLauncherPrivate;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_ptr_array_unref0(var) ((var == NULL) ? NULL : (var = (g_ptr_array_unref (var), NULL)))
#define _g_value_array_free0(var) ((var == NULL) ? NULL : (var = (g_value_array_free (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define _gdk_event_free0(var) ((var == NULL) ? NULL : (var = (gdk_event_free (var), NULL)))
#define __g_slist_free__g_object_unref0_0(var) ((var == NULL) ? NULL : (var = (_g_slist_free__g_object_unref0_ (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _SimpleLauncher {
	AwnApplet parent_instance;
	SimpleLauncherPrivate * priv;
};

struct _SimpleLauncherClass {
	AwnAppletClass parent_class;
};

struct _SimpleLauncherPrivate {
	AwnIconBox* icon_box;
	AwnThemedIcon* add_icon;
	GtkMenu* menu;
	GtkMenu* add_icon_menu;
	GtkMenuItem* remove_menu_item;
	GtkMenuItem* edit_menu_item;
	DesktopAgnosticConfigClient* client;
	gchar* config_dir;
	GPtrArray* launchers;
	guint timer_id;
	GValueArray* _launcher_list;
};


static gpointer simple_launcher_parent_class = NULL;

GType simple_launcher_get_type (void) G_GNUC_CONST;
#define SIMPLE_LAUNCHER_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_SIMPLE_LAUNCHER, SimpleLauncherPrivate))
enum  {
	SIMPLE_LAUNCHER_DUMMY_PROPERTY,
	SIMPLE_LAUNCHER_LAUNCHER_LIST
};
#define SIMPLE_LAUNCHER_DESKTOP_ENTRY "desktop-entry-object"
SimpleLauncher* simple_launcher_new (const gchar* canonical_name, const gchar* uid, gint panel_id);
SimpleLauncher* simple_launcher_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id);
static void simple_launcher_init_widgets (SimpleLauncher* self);
static void simple_launcher_launchers_changed (SimpleLauncher* self);
static void _simple_launcher_launchers_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self);
static void simple_launcher_create_new_launcher (SimpleLauncher* self);
static void _simple_launcher_create_new_launcher_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_edit_clicked (SimpleLauncher* self);
static void _simple_launcher_edit_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_remove_clicked (SimpleLauncher* self);
static void _simple_launcher_remove_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_add_folders (SimpleLauncher* self);
static void _simple_launcher_add_folders_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self);
static void simple_launcher_uri_received (SimpleLauncher* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint time_);
static void _simple_launcher_uri_received_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self);
static gboolean __lambda3_ (SimpleLauncher* self);
static gboolean ___lambda3__gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self);
static void simple_launcher_on_add_icon_clicked (SimpleLauncher* self);
static void _simple_launcher_on_add_icon_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void _simple_launcher_on_add_icon_clicked_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self);
static void simple_launcher_on_size_changed (SimpleLauncher* self);
static void _simple_launcher_on_size_changed_awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self);
static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle);
static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value);
static void simple_launcher_process_uri (SimpleLauncher* self, DesktopAgnosticVFSFile* file);
static void _g_object_unref0_ (gpointer var);
static void _g_slist_free__g_object_unref0_ (GSList* self);
static gchar* simple_launcher_pick_icon_name (SimpleLauncher* self, gchar** icon_names, int icon_names_length1);
static DesktopAgnosticVFSFile* simple_launcher_get_new_desktop_file (SimpleLauncher* self);
static AwnThemedIcon* simple_launcher_create_launcher (SimpleLauncher* self, const gchar* path);
static void _vala_array_add2 (gint** array, int* length, int* size, gint value);
static void simple_launcher_remove_launcher (SimpleLauncher* self, AwnThemedIcon* launcher, gboolean delete_desktop_file);
static void simple_launcher_on_launcher_clicked (SimpleLauncher* self, AwnIcon* launcher);
static void _simple_launcher_on_launcher_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self);
static void simple_launcher_on_launcher_ctx_menu (SimpleLauncher* self, AwnIcon* launcher, GdkEventButton* event);
static void _simple_launcher_on_launcher_ctx_menu_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self);
static gboolean simple_launcher_on_launcher_drag_motion (SimpleLauncher* self);
static gboolean _simple_launcher_on_launcher_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self);
static gboolean __lambda2_ (SimpleLauncher* self);
static gboolean ___lambda2__gsource_func (gpointer self);
GValueArray* simple_launcher_get_launcher_list (SimpleLauncher* self);
void simple_launcher_set_launcher_list (SimpleLauncher* self, GValueArray* value);
static GObject * simple_launcher_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
static void simple_launcher_finalize (GObject* obj);
static void _vala_simple_launcher_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec);
static void _vala_simple_launcher_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec);
AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id);
static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func);

static const GtkTargetEntry SIMPLE_LAUNCHER_targets[2] = {{"text/uri-list", (guint) 0, (guint) 0}, {"text/plain", (guint) 0, (guint) 0}};

static void _simple_launcher_launchers_changed_g_object_notify (GObject* _sender, GParamSpec* pspec, gpointer self) {
	simple_launcher_launchers_changed (self);
}


SimpleLauncher* simple_launcher_construct (GType object_type, const gchar* canonical_name, const gchar* uid, gint panel_id) {
	SimpleLauncher * self = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	self = (SimpleLauncher*) g_object_new (object_type, "canonical-name", _tmp0_, "uid", _tmp1_, "panel-id", _tmp2_, NULL);
	simple_launcher_init_widgets (self);
	g_signal_connect_object ((GObject*) self, "notify::launcher-list", (GCallback) _simple_launcher_launchers_changed_g_object_notify, self, 0);
	simple_launcher_launchers_changed (self);
	return self;
}


SimpleLauncher* simple_launcher_new (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	return simple_launcher_construct (TYPE_SIMPLE_LAUNCHER, canonical_name, uid, panel_id);
}


static gpointer _g_object_ref0 (gpointer self) {
	return self ? g_object_ref (self) : NULL;
}


static void _simple_launcher_create_new_launcher_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_create_new_launcher (self);
}


static void _simple_launcher_edit_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_edit_clicked (self);
}


static void _simple_launcher_remove_clicked_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_remove_clicked (self);
}


static void _simple_launcher_add_folders_gtk_menu_item_activate (GtkMenuItem* _sender, gpointer self) {
	simple_launcher_add_folders (self);
}


static void _simple_launcher_uri_received_gtk_widget_drag_data_received (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, GtkSelectionData* selection_data, guint info, guint time_, gpointer self) {
	simple_launcher_uri_received (self, context, x, y, selection_data, info, time_);
}


static gboolean __lambda3_ (SimpleLauncher* self) {
	gboolean result = FALSE;
	AwnThemedIcon* _tmp0_;
	AwnEffects* _tmp1_ = NULL;
	_tmp0_ = self->priv->add_icon;
	_tmp1_ = awn_overlayable_get_effects ((AwnOverlayable*) _tmp0_);
	awn_effects_start_ex (_tmp1_, AWN_EFFECT_LAUNCHING, 1, FALSE, FALSE);
	result = FALSE;
	return result;
}


static gboolean ___lambda3__gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self) {
	gboolean result;
	result = __lambda3_ (self);
	return result;
}


static void _simple_launcher_on_add_icon_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	simple_launcher_on_add_icon_clicked (self);
}


static void _simple_launcher_on_add_icon_clicked_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self) {
	simple_launcher_on_add_icon_clicked (self);
}


static void _simple_launcher_on_size_changed_awn_applet_size_changed (AwnApplet* _sender, gint size, gpointer self) {
	simple_launcher_on_size_changed (self);
}


static void simple_launcher_init_widgets (SimpleLauncher* self) {
	GtkWidget* _tmp0_ = NULL;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* about_item1;
	GtkWidget* _tmp2_ = NULL;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* about_item2;
	GtkWidget* _tmp4_ = NULL;
	GtkMenu* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* add_launcher_item1;
	GtkMenu* _tmp7_;
	GtkMenu* _tmp8_;
	GtkSeparatorMenuItem* _tmp9_;
	GtkSeparatorMenuItem* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenu* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenu* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenu* _tmp19_;
	GtkSeparatorMenuItem* _tmp20_;
	GtkSeparatorMenuItem* _tmp21_;
	GtkMenu* _tmp22_;
	GtkMenu* _tmp23_;
	GtkWidget* _tmp24_ = NULL;
	GtkMenu* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* add_launcher_item2;
	GtkMenu* _tmp27_;
	GtkMenuItem* _tmp28_;
	GtkMenuItem* add_folders_item;
	GtkMenu* _tmp29_;
	GtkMenu* _tmp30_;
	GtkSeparatorMenuItem* _tmp31_;
	GtkSeparatorMenuItem* _tmp32_;
	GtkMenu* _tmp33_;
	GtkMenu* _tmp34_;
	AwnIconBox* _tmp35_;
	AwnThemedIcon* _tmp36_;
	AwnThemedIcon* _tmp37_;
	AwnThemedIcon* _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	AwnThemedIcon* _tmp41_;
	AwnThemedIcon* _tmp42_;
	AwnThemedIcon* _tmp43_;
	AwnThemedIcon* _tmp44_;
	AwnThemedIcon* _tmp45_;
	AwnThemedIcon* _tmp46_;
	const gchar* _tmp47_;
	const gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	AwnThemedIcon* _tmp51_;
	AwnThemedIcon* _tmp52_;
	AwnIconBox* _tmp53_;
	AwnThemedIcon* _tmp54_;
	AwnIconBox* _tmp55_;
	AwnThemedIcon* _tmp56_;
	AwnIconBox* _tmp57_;
	AwnIconBox* _tmp58_;
	g_return_if_fail (self != NULL);
	_tmp0_ = awn_applet_create_about_item_simple ((AwnApplet*) self, "Copyright © 2010 Michal Hruby", AWN_APPLET_LICENSE_GPLV2, VERSION);
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, GTK_TYPE_MENU_ITEM) ? ((GtkMenuItem*) _tmp0_) : NULL);
	about_item1 = _tmp1_;
	_tmp2_ = awn_applet_create_about_item_simple ((AwnApplet*) self, "Copyright © 2010 Michal Hruby", AWN_APPLET_LICENSE_GPLV2, VERSION);
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, GTK_TYPE_MENU_ITEM) ? ((GtkMenuItem*) _tmp2_) : NULL);
	about_item2 = _tmp3_;
	_tmp4_ = awn_applet_create_default_menu ((AwnApplet*) self);
	_tmp5_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp4_, GTK_TYPE_MENU) ? ((GtkMenu*) _tmp4_) : NULL);
	_g_object_unref0 (self->priv->menu);
	self->priv->menu = _tmp5_;
	_tmp6_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Add Launcher...");
	g_object_ref_sink (_tmp6_);
	add_launcher_item1 = _tmp6_;
	g_signal_connect_object (add_launcher_item1, "activate", (GCallback) _simple_launcher_create_new_launcher_gtk_menu_item_activate, self, 0);
	_tmp7_ = self->priv->menu;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp7_, (GtkWidget*) add_launcher_item1);
	_tmp8_ = self->priv->menu;
	_tmp9_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp9_);
	_tmp10_ = _tmp9_;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp8_, (GtkWidget*) ((GtkMenuItem*) _tmp10_));
	_g_object_unref0 (_tmp10_);
	_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Edit Launcher");
	g_object_ref_sink (_tmp11_);
	_g_object_unref0 (self->priv->edit_menu_item);
	self->priv->edit_menu_item = _tmp11_;
	_tmp12_ = self->priv->edit_menu_item;
	g_signal_connect_object (_tmp12_, "activate", (GCallback) _simple_launcher_edit_clicked_gtk_menu_item_activate, self, 0);
	_tmp13_ = self->priv->menu;
	_tmp14_ = self->priv->edit_menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, (GtkWidget*) _tmp14_);
	_tmp15_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Remove Launcher");
	g_object_ref_sink (_tmp15_);
	_g_object_unref0 (self->priv->remove_menu_item);
	self->priv->remove_menu_item = _tmp15_;
	_tmp16_ = self->priv->remove_menu_item;
	g_signal_connect_object (_tmp16_, "activate", (GCallback) _simple_launcher_remove_clicked_gtk_menu_item_activate, self, 0);
	_tmp17_ = self->priv->menu;
	_tmp18_ = self->priv->remove_menu_item;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = self->priv->menu;
	_tmp20_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp20_);
	_tmp21_ = _tmp20_;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp19_, (GtkWidget*) ((GtkMenuItem*) _tmp21_));
	_g_object_unref0 (_tmp21_);
	_tmp22_ = self->priv->menu;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp22_, (GtkWidget*) about_item1);
	_tmp23_ = self->priv->menu;
	gtk_widget_show_all ((GtkWidget*) _tmp23_);
	_tmp24_ = awn_applet_create_default_menu ((AwnApplet*) self);
	_tmp25_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp24_, GTK_TYPE_MENU) ? ((GtkMenu*) _tmp24_) : NULL);
	_g_object_unref0 (self->priv->add_icon_menu);
	self->priv->add_icon_menu = _tmp25_;
	_tmp26_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Add Launcher...");
	g_object_ref_sink (_tmp26_);
	add_launcher_item2 = _tmp26_;
	g_signal_connect_object (add_launcher_item2, "activate", (GCallback) _simple_launcher_create_new_launcher_gtk_menu_item_activate, self, 0);
	_tmp27_ = self->priv->add_icon_menu;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp27_, (GtkWidget*) add_launcher_item2);
	_tmp28_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("Add common folders");
	g_object_ref_sink (_tmp28_);
	add_folders_item = _tmp28_;
	g_signal_connect_object (add_folders_item, "activate", (GCallback) _simple_launcher_add_folders_gtk_menu_item_activate, self, 0);
	_tmp29_ = self->priv->add_icon_menu;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp29_, (GtkWidget*) add_folders_item);
	_tmp30_ = self->priv->add_icon_menu;
	_tmp31_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
	g_object_ref_sink (_tmp31_);
	_tmp32_ = _tmp31_;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp30_, (GtkWidget*) ((GtkMenuItem*) _tmp32_));
	_g_object_unref0 (_tmp32_);
	_tmp33_ = self->priv->add_icon_menu;
	gtk_menu_shell_append ((GtkMenuShell*) _tmp33_, (GtkWidget*) about_item2);
	_tmp34_ = self->priv->add_icon_menu;
	gtk_widget_show_all ((GtkWidget*) _tmp34_);
	_tmp35_ = (AwnIconBox*) awn_icon_box_new_for_applet ((AwnApplet*) self);
	g_object_ref_sink (_tmp35_);
	_g_object_unref0 (self->priv->icon_box);
	self->priv->icon_box = _tmp35_;
	_tmp36_ = (AwnThemedIcon*) awn_themed_icon_new ();
	g_object_ref_sink (_tmp36_);
	_g_object_unref0 (self->priv->add_icon);
	self->priv->add_icon = _tmp36_;
	_tmp37_ = self->priv->add_icon;
	g_object_set (_tmp37_, "drag-and-drop", FALSE, NULL);
	_tmp38_ = self->priv->add_icon;
	_tmp39_ = awn_applet_get_size ((AwnApplet*) self);
	_tmp40_ = _tmp39_;
	awn_themed_icon_set_size (_tmp38_, _tmp40_);
	_tmp41_ = self->priv->add_icon;
	gtk_drag_dest_set ((GtkWidget*) _tmp41_, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_DROP, SIMPLE_LAUNCHER_targets, G_N_ELEMENTS (SIMPLE_LAUNCHER_targets), GDK_ACTION_COPY);
	_tmp42_ = self->priv->add_icon;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_TYPE (_tmp42_, GTK_TYPE_WIDGET) ? ((GtkWidget*) _tmp42_) : NULL, "drag-data-received", (GCallback) _simple_launcher_uri_received_gtk_widget_drag_data_received, self, 0);
	_tmp43_ = self->priv->add_icon;
	g_signal_connect_object ((GtkWidget*) _tmp43_, "drag-motion", (GCallback) ___lambda3__gtk_widget_drag_motion, self, G_CONNECT_AFTER);
	_tmp44_ = self->priv->add_icon;
	g_signal_connect_object ((AwnIcon*) _tmp44_, "clicked", (GCallback) _simple_launcher_on_add_icon_clicked_awn_icon_clicked, self, 0);
	_tmp45_ = self->priv->add_icon;
	g_signal_connect_object ((AwnIcon*) _tmp45_, "context-menu-popup", (GCallback) _simple_launcher_on_add_icon_clicked_awn_icon_context_menu_popup, self, 0);
	_tmp46_ = self->priv->add_icon;
	_tmp47_ = awn_applet_get_canonical_name ((AwnApplet*) self);
	_tmp48_ = _tmp47_;
	_tmp49_ = awn_applet_get_uid ((AwnApplet*) self);
	_tmp50_ = _tmp49_;
	awn_themed_icon_set_info_simple (_tmp46_, _tmp48_, _tmp50_, "add");
	_tmp51_ = self->priv->add_icon;
	awn_icon_set_tooltip_text ((AwnIcon*) _tmp51_, "Drop launcher here");
	_tmp52_ = self->priv->add_icon;
	gtk_widget_show ((GtkWidget*) _tmp52_);
	_tmp53_ = self->priv->icon_box;
	_tmp54_ = self->priv->add_icon;
	gtk_container_add ((GtkContainer*) _tmp53_, (GtkWidget*) _tmp54_);
	_tmp55_ = self->priv->icon_box;
	_tmp56_ = self->priv->add_icon;
	gtk_box_set_child_packing ((GtkBox*) _tmp55_, (GtkWidget*) _tmp56_, FALSE, FALSE, (guint) 0, GTK_PACK_END);
	_tmp57_ = self->priv->icon_box;
	gtk_widget_show ((GtkWidget*) _tmp57_);
	_tmp58_ = self->priv->icon_box;
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp58_);
	g_signal_connect_object ((AwnApplet*) self, "size-changed", (GCallback) _simple_launcher_on_size_changed_awn_applet_size_changed, self, 0);
	_g_object_unref0 (add_folders_item);
	_g_object_unref0 (add_launcher_item2);
	_g_object_unref0 (add_launcher_item1);
	_g_object_unref0 (about_item2);
	_g_object_unref0 (about_item1);
}


static void simple_launcher_on_size_changed (SimpleLauncher* self) {
	AwnIconBox* _tmp0_;
	GList* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->icon_box;
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
	{
		GList* w_collection = NULL;
		GList* w_it = NULL;
		w_collection = _tmp1_;
		for (w_it = w_collection; w_it != NULL; w_it = w_it->next) {
			GtkWidget* w = NULL;
			w = (GtkWidget*) w_it->data;
			{
				GtkWidget* _tmp2_;
				AwnThemedIcon* i;
				AwnThemedIcon* _tmp3_;
				_tmp2_ = w;
				i = G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, AWN_TYPE_THEMED_ICON) ? ((AwnThemedIcon*) _tmp2_) : NULL;
				_tmp3_ = i;
				if (_tmp3_ != NULL) {
					AwnThemedIcon* _tmp4_;
					gint _tmp5_;
					gint _tmp6_;
					_tmp4_ = i;
					_tmp5_ = awn_applet_get_size ((AwnApplet*) self);
					_tmp6_ = _tmp5_;
					awn_themed_icon_set_size (_tmp4_, _tmp6_);
				}
			}
		}
		_g_list_free0 (w_collection);
	}
}


static void simple_launcher_on_add_icon_clicked (SimpleLauncher* self) {
	GdkEvent* _tmp0_ = NULL;
	GdkEvent* e;
	guint _tmp1_ = 0U;
	gboolean _tmp2_ = FALSE;
	GdkEvent* _tmp3_;
	gboolean _tmp6_;
	guint _tmp10_;
	guint button;
	AwnThemedIcon* _tmp11_;
	GtkMenu* _tmp12_;
	guint32 _tmp13_ = 0U;
	g_return_if_fail (self != NULL);
	_tmp0_ = gtk_get_current_event ();
	e = _tmp0_;
	_tmp3_ = e;
	if (_tmp3_ == NULL) {
		_tmp2_ = TRUE;
	} else {
		GdkEvent* _tmp4_;
		GdkEventType _tmp5_;
		_tmp4_ = e;
		_tmp5_ = _tmp4_->type;
		_tmp2_ = _tmp5_ != GDK_BUTTON_PRESS;
	}
	_tmp6_ = _tmp2_;
	if (_tmp6_) {
		_tmp1_ = (guint) 0;
	} else {
		GdkEvent* _tmp7_;
		GdkEventButton _tmp8_;
		guint _tmp9_;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->button;
		_tmp9_ = _tmp8_.button;
		_tmp1_ = _tmp9_;
	}
	_tmp10_ = _tmp1_;
	button = _tmp10_;
	_tmp11_ = self->priv->add_icon;
	_tmp12_ = self->priv->add_icon_menu;
	_tmp13_ = gtk_get_current_event_time ();
	awn_icon_popup_gtk_menu ((AwnIcon*) _tmp11_, (GtkWidget*) _tmp12_, button, _tmp13_);
	_gdk_event_free0 (e);
}


static gboolean _vala_string_array_contains (gchar** stack, int stack_length, gchar* needle) {
	int i;
	for (i = 0; i < stack_length; i++) {
		if (g_strcmp0 (stack[i], needle) == 0) {
			return TRUE;
		}
	}
	return FALSE;
}


static void _vala_array_add1 (gchar*** array, int* length, int* size, gchar* value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}


static void simple_launcher_add_folders (SimpleLauncher* self) {
	gchar** _tmp0_ = NULL;
	gchar** directories;
	gint directories_length1;
	gint _directories_size_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	directories = _tmp0_;
	directories_length1 = 0;
	_directories_size_ = directories_length1;
	g_object_freeze_notify ((GObject*) self);
	{
		GUserDirectory dir;
		dir = G_USER_DIRECTORY_DESKTOP;
		{
			gboolean _tmp1_;
			_tmp1_ = TRUE;
			while (TRUE) {
				gboolean _tmp2_;
				GUserDirectory _tmp4_;
				GUserDirectory _tmp5_;
				const gchar* _tmp6_ = NULL;
				gchar* _tmp7_;
				gchar* path;
				const gchar* _tmp8_;
				gchar** _tmp9_;
				gint _tmp9__length1;
				gchar** _tmp10_;
				gint _tmp10__length1;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				const gchar* _tmp13_;
				DesktopAgnosticVFSFile* _tmp14_ = NULL;
				DesktopAgnosticVFSFile* f;
				DesktopAgnosticVFSFile* _tmp15_;
				gboolean _tmp16_ = FALSE;
				_tmp2_ = _tmp1_;
				if (!_tmp2_) {
					GUserDirectory _tmp3_;
					_tmp3_ = dir;
					dir = _tmp3_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp4_ = dir;
				if (!(_tmp4_ <= G_USER_DIRECTORY_VIDEOS)) {
					break;
				}
				_tmp5_ = dir;
				_tmp6_ = g_get_user_special_dir (_tmp5_);
				_tmp7_ = g_strdup (_tmp6_);
				path = _tmp7_;
				_tmp8_ = path;
				_tmp9_ = directories;
				_tmp9__length1 = directories_length1;
				if (_vala_string_array_contains (_tmp9_, _tmp9__length1, _tmp8_)) {
					_g_free0 (path);
					continue;
				}
				_tmp10_ = directories;
				_tmp10__length1 = directories_length1;
				_tmp11_ = path;
				_tmp12_ = g_strdup (_tmp11_);
				_vala_array_add1 (&directories, &directories_length1, &_directories_size_, _tmp12_);
				_tmp13_ = path;
				_tmp14_ = desktop_agnostic_vfs_file_new_for_path (_tmp13_, &_inner_error_);
				f = _tmp14_;
				if (_inner_error_ != NULL) {
					_g_free0 (path);
					directories = (_vala_array_free (directories, directories_length1, (GDestroyNotify) g_free), NULL);
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
					g_clear_error (&_inner_error_);
					return;
				}
				_tmp15_ = f;
				_tmp16_ = desktop_agnostic_vfs_file_exists (_tmp15_);
				if (_tmp16_) {
					DesktopAgnosticVFSFile* _tmp17_;
					_tmp17_ = f;
					simple_launcher_process_uri (self, _tmp17_);
				}
				_g_object_unref0 (f);
				_g_free0 (path);
			}
		}
	}
	g_object_thaw_notify ((GObject*) self);
	directories = (_vala_array_free (directories, directories_length1, (GDestroyNotify) g_free), NULL);
}


static void _g_object_unref0_ (gpointer var) {
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}


static void _g_slist_free__g_object_unref0_ (GSList* self) {
	g_slist_foreach (self, (GFunc) _g_object_unref0_, NULL);
	g_slist_free (self);
}


static void simple_launcher_uri_received (SimpleLauncher* self, GdkDragContext* context, gint x, gint y, GtkSelectionData* data, guint info, guint time_) {
	gboolean _tmp0_ = FALSE;
	GtkSelectionData* _tmp1_;
	gboolean _tmp4_;
	GtkSelectionData* _tmp7_;
	guchar* _tmp8_;
	gint _tmp8__length1;
	GSList* _tmp9_ = NULL;
	GSList* files;
	GSList* _tmp10_;
	gconstpointer _tmp11_;
	GdkDragContext* _tmp12_;
	guint _tmp13_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (context != NULL);
	g_return_if_fail (data != NULL);
	_tmp1_ = data;
	if (_tmp1_ == NULL) {
		_tmp0_ = TRUE;
	} else {
		GtkSelectionData* _tmp2_;
		gint _tmp3_ = 0;
		_tmp2_ = data;
		_tmp3_ = gtk_selection_data_get_length (_tmp2_);
		_tmp0_ = _tmp3_ == 0;
	}
	_tmp4_ = _tmp0_;
	if (_tmp4_) {
		GdkDragContext* _tmp5_;
		guint _tmp6_;
		_tmp5_ = context;
		_tmp6_ = time_;
		gtk_drag_finish (_tmp5_, FALSE, FALSE, (guint32) _tmp6_);
		return;
	}
	_tmp7_ = data;
	_tmp8_ = _tmp7_->data;
	_tmp8__length1 = -1;
	_tmp9_ = desktop_agnostic_vfs_files_from_uri_list ((const gchar*) _tmp8_, &_inner_error_);
	files = _tmp9_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_tmp10_ = files;
	_tmp11_ = _tmp10_->data;
	simple_launcher_process_uri (self, (DesktopAgnosticVFSFile*) _tmp11_);
	_tmp12_ = context;
	_tmp13_ = time_;
	gtk_drag_finish (_tmp12_, TRUE, FALSE, (guint32) _tmp13_);
	__g_slist_free__g_object_unref0_0 (files);
}


static gchar* simple_launcher_pick_icon_name (SimpleLauncher* self, gchar** icon_names, int icon_names_length1) {
	gchar* result = NULL;
	GtkIconTheme* _tmp0_ = NULL;
	GtkIconTheme* _tmp1_;
	GtkIconTheme* it;
	gchar** _tmp2_;
	gint _tmp2__length1;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = gtk_icon_theme_get_default ();
	_tmp1_ = _g_object_ref0 (_tmp0_);
	it = _tmp1_;
	_tmp2_ = icon_names;
	_tmp2__length1 = icon_names_length1;
	{
		gchar** icon_collection = NULL;
		gint icon_collection_length1 = 0;
		gint _icon_collection_size_ = 0;
		gint icon_it = 0;
		icon_collection = _tmp2_;
		icon_collection_length1 = _tmp2__length1;
		for (icon_it = 0; icon_it < _tmp2__length1; icon_it = icon_it + 1) {
			const gchar* icon = NULL;
			icon = icon_collection[icon_it];
			{
				GtkIconTheme* _tmp3_;
				const gchar* _tmp4_;
				gboolean _tmp5_ = FALSE;
				_tmp3_ = it;
				_tmp4_ = icon;
				_tmp5_ = gtk_icon_theme_has_icon (_tmp3_, _tmp4_);
				if (_tmp5_) {
					const gchar* _tmp6_;
					gchar* _tmp7_;
					_tmp6_ = icon;
					_tmp7_ = g_strdup (_tmp6_);
					result = _tmp7_;
					_g_object_unref0 (it);
					return result;
				}
			}
		}
	}
	result = NULL;
	_g_object_unref0 (it);
	return result;
}


static void simple_launcher_process_uri (SimpleLauncher* self, DesktopAgnosticVFSFile* file) {
	DesktopAgnosticVFSFile* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* uri;
	const gchar* _tmp3_;
	DesktopAgnosticVFSFile* _tmp4_ = NULL;
	DesktopAgnosticVFSFile* df;
	DesktopAgnosticVFSFile* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* path;
	const gchar* _tmp8_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp51_;
	GValue _tmp52_ = {0};
	GValue v;
	GValueArray* _tmp53_;
	GValue _tmp54_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (file != NULL);
	_tmp0_ = file;
	_tmp1_ = desktop_agnostic_vfs_file_get_uri (_tmp0_);
	_tmp2_ = _tmp1_;
	uri = _tmp2_;
	_tmp3_ = uri;
	g_debug ("simple-launcher.vala:232: received %s", _tmp3_);
	_tmp4_ = simple_launcher_get_new_desktop_file (self);
	df = _tmp4_;
	_tmp5_ = df;
	_tmp6_ = desktop_agnostic_vfs_file_get_path (_tmp5_);
	_tmp7_ = _tmp6_;
	path = _tmp7_;
	_tmp8_ = uri;
	_tmp9_ = g_str_has_suffix (_tmp8_, ".desktop");
	if (_tmp9_) {
		DesktopAgnosticVFSFile* _tmp10_;
		gboolean _tmp11_ = FALSE;
		_tmp10_ = file;
		_tmp11_ = desktop_agnostic_vfs_file_is_writable (_tmp10_);
		if (_tmp11_) {
			DesktopAgnosticVFSFile* _tmp12_;
			DesktopAgnosticFDODesktopEntry* _tmp13_ = NULL;
			DesktopAgnosticFDODesktopEntry* de;
			DesktopAgnosticFDODesktopEntry* _tmp14_;
			DesktopAgnosticVFSFile* _tmp15_;
			_tmp12_ = file;
			_tmp13_ = desktop_agnostic_fdo_desktop_entry_new_for_file (_tmp12_, &_inner_error_);
			de = _tmp13_;
			if (_inner_error_ != NULL) {
				_g_free0 (path);
				_g_object_unref0 (df);
				_g_free0 (uri);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_tmp14_ = de;
			_tmp15_ = df;
			desktop_agnostic_fdo_desktop_entry_save (_tmp14_, _tmp15_, &_inner_error_);
			if (_inner_error_ != NULL) {
				_g_object_unref0 (de);
				_g_free0 (path);
				_g_object_unref0 (df);
				_g_free0 (uri);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return;
			}
			_g_object_unref0 (de);
		} else {
			DesktopAgnosticVFSFile* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			_tmp16_ = file;
			_tmp17_ = desktop_agnostic_vfs_file_get_path (_tmp16_);
			_tmp18_ = _tmp17_;
			_g_free0 (path);
			path = _tmp18_;
		}
	} else {
		DesktopAgnosticFDODesktopEntry* _tmp19_ = NULL;
		DesktopAgnosticFDODesktopEntry* link_entry;
		DesktopAgnosticFDODesktopEntry* _tmp20_;
		DesktopAgnosticFDODesktopEntry* _tmp21_;
		const gchar* _tmp22_;
		gchar* _tmp23_ = NULL;
		gchar* _tmp24_;
		gchar* _tmp25_ = NULL;
		gchar* _tmp26_;
		DesktopAgnosticFDODesktopEntry* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* icon_name;
		DesktopAgnosticFDODesktopEntry* _tmp47_;
		const gchar* _tmp48_;
		DesktopAgnosticFDODesktopEntry* _tmp49_;
		DesktopAgnosticVFSFile* _tmp50_;
		_tmp19_ = desktop_agnostic_fdo_desktop_entry_new (&_inner_error_);
		link_entry = _tmp19_;
		if (_inner_error_ != NULL) {
			_g_free0 (path);
			_g_object_unref0 (df);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp20_ = link_entry;
		desktop_agnostic_fdo_desktop_entry_set_entry_type (_tmp20_, DESKTOP_AGNOSTIC_FDO_DESKTOP_ENTRY_TYPE_LINK);
		_tmp21_ = link_entry;
		_tmp22_ = uri;
		_tmp23_ = g_path_get_basename (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp25_ = g_uri_unescape_string (_tmp24_, NULL);
		_tmp26_ = _tmp25_;
		desktop_agnostic_fdo_desktop_entry_set_name (_tmp21_, _tmp26_);
		_g_free0 (_tmp26_);
		_g_free0 (_tmp24_);
		_tmp27_ = link_entry;
		_tmp28_ = uri;
		desktop_agnostic_fdo_desktop_entry_set_string (_tmp27_, "URL", _tmp28_);
		_tmp29_ = g_strdup ("image-missing");
		icon_name = _tmp29_;
		{
			const gchar* _tmp30_;
			DesktopAgnosticVFSFile* _tmp31_ = NULL;
			DesktopAgnosticVFSFile* f;
			DesktopAgnosticVFSFile* _tmp32_;
			gboolean _tmp33_ = FALSE;
			_tmp30_ = uri;
			_tmp31_ = desktop_agnostic_vfs_file_new_for_uri (_tmp30_, &_inner_error_);
			f = _tmp31_;
			if (_inner_error_ != NULL) {
				goto __catch0_g_error;
			}
			_tmp32_ = f;
			_tmp33_ = desktop_agnostic_vfs_file_is_native (_tmp32_);
			if (_tmp33_) {
				DesktopAgnosticVFSFile* _tmp34_;
				gint _tmp35_ = 0;
				gchar** _tmp36_ = NULL;
				gchar** _tmp37_;
				gint _tmp37__length1;
				gint __tmp37__size_;
				gchar** _tmp38_;
				gint _tmp38__length1;
				gchar* _tmp39_ = NULL;
				gchar* _tmp40_;
				gchar* i;
				const gchar* _tmp41_;
				_tmp34_ = f;
				_tmp36_ = desktop_agnostic_vfs_file_get_icon_names (_tmp34_, &_tmp35_, &_inner_error_);
				_tmp37_ = _tmp36_;
				_tmp37__length1 = _tmp35_;
				__tmp37__size_ = _tmp37__length1;
				if (_inner_error_ != NULL) {
					_g_object_unref0 (f);
					goto __catch0_g_error;
				}
				_tmp38_ = _tmp37_;
				_tmp38__length1 = _tmp37__length1;
				_tmp39_ = simple_launcher_pick_icon_name (self, _tmp38_, _tmp37__length1);
				_tmp40_ = _tmp39_;
				_tmp38_ = (_vala_array_free (_tmp38_, _tmp38__length1, (GDestroyNotify) g_free), NULL);
				i = _tmp40_;
				_tmp41_ = i;
				if (_tmp41_ != NULL) {
					const gchar* _tmp42_;
					gchar* _tmp43_;
					_tmp42_ = i;
					_tmp43_ = g_strdup (_tmp42_);
					_g_free0 (icon_name);
					icon_name = _tmp43_;
				}
				_g_free0 (i);
			} else {
				gchar* _tmp44_;
				_tmp44_ = g_strdup ("unknown");
				_g_free0 (icon_name);
				icon_name = _tmp44_;
			}
			_g_object_unref0 (f);
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* err = NULL;
			GError* _tmp45_;
			const gchar* _tmp46_;
			err = _inner_error_;
			_inner_error_ = NULL;
			_tmp45_ = err;
			_tmp46_ = _tmp45_->message;
			g_warning ("simple-launcher.vala:276: %s", _tmp46_);
			_g_error_free0 (err);
		}
		__finally0:
		if (_inner_error_ != NULL) {
			_g_free0 (icon_name);
			_g_object_unref0 (link_entry);
			_g_free0 (path);
			_g_object_unref0 (df);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_tmp47_ = link_entry;
		_tmp48_ = icon_name;
		desktop_agnostic_fdo_desktop_entry_set_icon (_tmp47_, _tmp48_);
		_tmp49_ = link_entry;
		_tmp50_ = df;
		desktop_agnostic_fdo_desktop_entry_save (_tmp49_, _tmp50_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_free0 (icon_name);
			_g_object_unref0 (link_entry);
			_g_free0 (path);
			_g_object_unref0 (df);
			_g_free0 (uri);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		_g_free0 (icon_name);
		_g_object_unref0 (link_entry);
	}
	_tmp51_ = path;
	g_value_init (&_tmp52_, G_TYPE_STRING);
	g_value_set_string (&_tmp52_, _tmp51_);
	v = _tmp52_;
	_tmp53_ = self->priv->_launcher_list;
	_tmp54_ = v;
	g_value_array_append (_tmp53_, &_tmp54_);
	g_object_notify ((GObject*) self, "launcher-list");
	G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	_g_free0 (path);
	_g_object_unref0 (df);
	_g_free0 (uri);
}


static DesktopAgnosticVFSFile* simple_launcher_get_new_desktop_file (SimpleLauncher* self) {
	DesktopAgnosticVFSFile* result = NULL;
	DesktopAgnosticVFSFile* f;
	gint counter;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	f = NULL;
	counter = 1;
	{
		gboolean _tmp0_;
		_tmp0_ = TRUE;
		while (TRUE) {
			gboolean _tmp1_;
			const gchar* _tmp4_;
			gint _tmp5_;
			gchar* _tmp6_ = NULL;
			gchar* _tmp7_;
			gchar* _tmp8_ = NULL;
			gchar* _tmp9_;
			gchar* path;
			const gchar* _tmp10_;
			DesktopAgnosticVFSFile* _tmp11_ = NULL;
			DesktopAgnosticVFSFile* _tmp12_;
			_tmp1_ = _tmp0_;
			if (!_tmp1_) {
				DesktopAgnosticVFSFile* _tmp2_;
				gboolean _tmp3_ = FALSE;
				_tmp2_ = f;
				_tmp3_ = desktop_agnostic_vfs_file_exists (_tmp2_);
				if (!_tmp3_) {
					break;
				}
			}
			_tmp0_ = FALSE;
			_tmp4_ = self->priv->config_dir;
			_tmp5_ = counter;
			counter = _tmp5_ + 1;
			_tmp6_ = g_strdup_printf ("launcher-%d.desktop", _tmp5_);
			_tmp7_ = _tmp6_;
			_tmp8_ = g_build_filename (_tmp4_, _tmp7_, NULL, NULL);
			_tmp9_ = _tmp8_;
			_g_free0 (_tmp7_);
			path = _tmp9_;
			_tmp10_ = path;
			_tmp11_ = desktop_agnostic_vfs_file_new_for_path (_tmp10_, &_inner_error_);
			_tmp12_ = _tmp11_;
			if (_inner_error_ != NULL) {
				_g_free0 (path);
				_g_object_unref0 (f);
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
				g_clear_error (&_inner_error_);
				return NULL;
			}
			_g_object_unref0 (f);
			f = _tmp12_;
			_g_free0 (path);
		}
	}
	result = f;
	return result;
}


static void simple_launcher_create_new_launcher (SimpleLauncher* self) {
	DesktopAgnosticVFSFile* _tmp0_ = NULL;
	DesktopAgnosticVFSFile* f;
	DesktopAgnosticVFSFile* _tmp1_;
	DesktopAgnosticUILauncherEditorDialog* _tmp2_;
	DesktopAgnosticUILauncherEditorDialog* d;
	DesktopAgnosticUILauncherEditorDialog* _tmp3_;
	DesktopAgnosticUILauncherEditorDialog* _tmp4_;
	gint _tmp5_ = 0;
	DesktopAgnosticUILauncherEditorDialog* _tmp12_;
	g_return_if_fail (self != NULL);
	_tmp0_ = simple_launcher_get_new_desktop_file (self);
	f = _tmp0_;
	_tmp1_ = f;
	_tmp2_ = desktop_agnostic_ui_launcher_editor_dialog_new (_tmp1_, NULL, TRUE);
	g_object_ref_sink (_tmp2_);
	d = _tmp2_;
	_tmp3_ = d;
	gtk_widget_show_all ((GtkWidget*) _tmp3_);
	_tmp4_ = d;
	_tmp5_ = gtk_dialog_run ((GtkDialog*) _tmp4_);
	if (_tmp5_ == ((gint) GTK_RESPONSE_APPLY)) {
		DesktopAgnosticVFSFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		GValue _tmp9_ = {0};
		GValue v;
		GValueArray* _tmp10_;
		GValue _tmp11_;
		_tmp6_ = f;
		_tmp7_ = desktop_agnostic_vfs_file_get_path (_tmp6_);
		_tmp8_ = _tmp7_;
		g_value_init (&_tmp9_, G_TYPE_STRING);
		g_value_take_string (&_tmp9_, _tmp8_);
		v = _tmp9_;
		_tmp10_ = self->priv->_launcher_list;
		_tmp11_ = v;
		g_value_array_append (_tmp10_, &_tmp11_);
		g_object_notify ((GObject*) self, "launcher-list");
		G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
	}
	_tmp12_ = d;
	gtk_object_destroy ((GtkObject*) _tmp12_);
	_g_object_unref0 (d);
	_g_object_unref0 (f);
}


static gint g_ptr_array_get_length (GPtrArray* self) {
	gint result;
	guint _tmp0_;
	g_return_val_if_fail (self != NULL, 0);
	_tmp0_ = self->len;
	result = (gint) _tmp0_;
	return result;
}


static void g_ptr_array_set_length (GPtrArray* self, gint value) {
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	g_ptr_array_set_size (self, _tmp0_);
}


static void _vala_array_add2 (gint** array, int* length, int* size, gint value) {
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gint, *array, *size);
	}
	(*array)[(*length)++] = value;
}


static void simple_launcher_launchers_changed (SimpleLauncher* self) {
	gint i = 0;
	gint* _tmp0_ = NULL;
	gint* invalid_launchers;
	gint invalid_launchers_length1;
	gint _invalid_launchers_size_;
	gint index;
	GValueArray* _tmp11_;
	GList* l;
	GList* _tmp69_;
	GPtrArray* _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	gboolean something_removed;
	gboolean _tmp85_;
	g_return_if_fail (self != NULL);
	_tmp0_ = g_new0 (gint, 0);
	invalid_launchers = _tmp0_;
	invalid_launchers_length1 = 0;
	_invalid_launchers_size_ = invalid_launchers_length1;
	{
		gboolean _tmp1_;
		i = 0;
		_tmp1_ = TRUE;
		while (TRUE) {
			gboolean _tmp2_;
			gint _tmp4_;
			GPtrArray* _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			GPtrArray* _tmp8_;
			gint _tmp9_;
			gconstpointer _tmp10_ = NULL;
			_tmp2_ = _tmp1_;
			if (!_tmp2_) {
				gint _tmp3_;
				_tmp3_ = i;
				i = _tmp3_ + 1;
			}
			_tmp1_ = FALSE;
			_tmp4_ = i;
			_tmp5_ = self->priv->launchers;
			_tmp6_ = g_ptr_array_get_length (_tmp5_);
			_tmp7_ = _tmp6_;
			if (!(_tmp4_ < _tmp7_)) {
				break;
			}
			_tmp8_ = self->priv->launchers;
			_tmp9_ = i;
			_tmp10_ = g_ptr_array_index (_tmp8_, (guint) _tmp9_);
			g_object_set_data_full ((GObject*) ((AwnThemedIcon*) _tmp10_), "untouched", (gpointer) ((gintptr) 1), NULL);
		}
	}
	index = 0;
	_tmp11_ = self->priv->_launcher_list;
	{
		GValueArray* v_collection = NULL;
		guint v_index = 0U;
		v_collection = _tmp11_;
		for (v_index = 0; v_index < v_collection->n_values; v_index = v_index + 1) {
			GValue _tmp12_ = {0};
			GValue v = {0};
			if (G_IS_VALUE (g_value_array_get_nth (v_collection, v_index))) {
				g_value_init (&_tmp12_, G_VALUE_TYPE (g_value_array_get_nth (v_collection, v_index)));
				g_value_copy (g_value_array_get_nth (v_collection, v_index), &_tmp12_);
			} else {
				_tmp12_ = *g_value_array_get_nth (v_collection, v_index);
			}
			v = _tmp12_;
			{
				const gchar* _tmp13_ = NULL;
				gchar* _tmp14_;
				gchar* de_path;
				gboolean found;
				gboolean _tmp45_;
				gint _tmp54_;
				_tmp13_ = g_value_get_string (&v);
				_tmp14_ = g_strdup (_tmp13_);
				de_path = _tmp14_;
				found = FALSE;
				{
					gboolean _tmp15_;
					i = 0;
					_tmp15_ = TRUE;
					while (TRUE) {
						gboolean _tmp16_;
						gint _tmp18_;
						GPtrArray* _tmp19_;
						gint _tmp20_;
						gint _tmp21_;
						GPtrArray* _tmp22_;
						gint _tmp23_;
						gconstpointer _tmp24_ = NULL;
						gconstpointer _tmp25_ = NULL;
						DesktopAgnosticFDODesktopEntry* _tmp26_;
						DesktopAgnosticFDODesktopEntry* de;
						gboolean _tmp27_ = FALSE;
						DesktopAgnosticFDODesktopEntry* _tmp28_;
						gboolean _tmp36_;
						_tmp16_ = _tmp15_;
						if (!_tmp16_) {
							gint _tmp17_;
							_tmp17_ = i;
							i = _tmp17_ + 1;
						}
						_tmp15_ = FALSE;
						_tmp18_ = i;
						_tmp19_ = self->priv->launchers;
						_tmp20_ = g_ptr_array_get_length (_tmp19_);
						_tmp21_ = _tmp20_;
						if (!(_tmp18_ < _tmp21_)) {
							break;
						}
						_tmp22_ = self->priv->launchers;
						_tmp23_ = i;
						_tmp24_ = g_ptr_array_index (_tmp22_, (guint) _tmp23_);
						_tmp25_ = g_object_get_data ((GObject*) ((AwnThemedIcon*) _tmp24_), SIMPLE_LAUNCHER_DESKTOP_ENTRY);
						_tmp26_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp25_);
						de = _tmp26_;
						_tmp28_ = de;
						if (_tmp28_ != NULL) {
							DesktopAgnosticFDODesktopEntry* _tmp29_;
							DesktopAgnosticVFSFile* _tmp30_;
							DesktopAgnosticVFSFile* _tmp31_;
							gchar* _tmp32_;
							gchar* _tmp33_;
							gchar* _tmp34_;
							const gchar* _tmp35_;
							_tmp29_ = de;
							_tmp30_ = desktop_agnostic_fdo_desktop_entry_get_file (_tmp29_);
							_tmp31_ = _tmp30_;
							_tmp32_ = desktop_agnostic_vfs_file_get_path (_tmp31_);
							_tmp33_ = _tmp32_;
							_tmp34_ = _tmp33_;
							_tmp35_ = de_path;
							_tmp27_ = g_strcmp0 (_tmp34_, _tmp35_) == 0;
							_g_free0 (_tmp34_);
						} else {
							_tmp27_ = FALSE;
						}
						_tmp36_ = _tmp27_;
						if (_tmp36_) {
							GPtrArray* _tmp37_;
							gint _tmp38_;
							gconstpointer _tmp39_ = NULL;
							AwnIconBox* _tmp40_;
							GPtrArray* _tmp41_;
							gint _tmp42_;
							gconstpointer _tmp43_ = NULL;
							gint _tmp44_;
							_tmp37_ = self->priv->launchers;
							_tmp38_ = i;
							_tmp39_ = g_ptr_array_index (_tmp37_, (guint) _tmp38_);
							g_object_set_data_full ((GObject*) ((AwnThemedIcon*) _tmp39_), "untouched", (gpointer) ((gintptr) 0), NULL);
							found = TRUE;
							_tmp40_ = self->priv->icon_box;
							_tmp41_ = self->priv->launchers;
							_tmp42_ = i;
							_tmp43_ = g_ptr_array_index (_tmp41_, (guint) _tmp42_);
							_tmp44_ = index;
							gtk_box_reorder_child ((GtkBox*) _tmp40_, (GtkWidget*) ((AwnThemedIcon*) _tmp43_), _tmp44_);
							_g_object_unref0 (de);
							break;
						}
						_g_object_unref0 (de);
					}
				}
				_tmp45_ = found;
				if (!_tmp45_) {
					const gchar* _tmp46_;
					AwnThemedIcon* _tmp47_ = NULL;
					AwnThemedIcon* icon;
					AwnThemedIcon* _tmp48_;
					_tmp46_ = de_path;
					_tmp47_ = simple_launcher_create_launcher (self, _tmp46_);
					icon = _tmp47_;
					_tmp48_ = icon;
					if (_tmp48_ != NULL) {
						AwnIconBox* _tmp49_;
						AwnThemedIcon* _tmp50_;
						gint _tmp51_;
						_tmp49_ = self->priv->icon_box;
						_tmp50_ = icon;
						_tmp51_ = index;
						gtk_box_reorder_child ((GtkBox*) _tmp49_, (GtkWidget*) _tmp50_, _tmp51_);
					} else {
						gint* _tmp52_;
						gint _tmp52__length1;
						gint _tmp53_;
						_tmp52_ = invalid_launchers;
						_tmp52__length1 = invalid_launchers_length1;
						_tmp53_ = index;
						_vala_array_add2 (&invalid_launchers, &invalid_launchers_length1, &_invalid_launchers_size_, _tmp53_);
					}
					_g_object_unref0 (icon);
				}
				_tmp54_ = index;
				index = _tmp54_ + 1;
				_g_free0 (de_path);
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			}
		}
	}
	l = NULL;
	{
		gboolean _tmp55_;
		i = 0;
		_tmp55_ = TRUE;
		while (TRUE) {
			gboolean _tmp56_;
			gint _tmp58_;
			GPtrArray* _tmp59_;
			gint _tmp60_;
			gint _tmp61_;
			GPtrArray* _tmp62_;
			gint _tmp63_;
			gconstpointer _tmp64_ = NULL;
			gconstpointer _tmp65_ = NULL;
			_tmp56_ = _tmp55_;
			if (!_tmp56_) {
				gint _tmp57_;
				_tmp57_ = i;
				i = _tmp57_ + 1;
			}
			_tmp55_ = FALSE;
			_tmp58_ = i;
			_tmp59_ = self->priv->launchers;
			_tmp60_ = g_ptr_array_get_length (_tmp59_);
			_tmp61_ = _tmp60_;
			if (!(_tmp58_ < _tmp61_)) {
				break;
			}
			_tmp62_ = self->priv->launchers;
			_tmp63_ = i;
			_tmp64_ = g_ptr_array_index (_tmp62_, (guint) _tmp63_);
			_tmp65_ = g_object_get_data ((GObject*) ((AwnThemedIcon*) _tmp64_), "untouched");
			if (((gint) ((gintptr) _tmp65_)) != 0) {
				GPtrArray* _tmp66_;
				gint _tmp67_;
				gconstpointer _tmp68_ = NULL;
				_tmp66_ = self->priv->launchers;
				_tmp67_ = i;
				_tmp68_ = g_ptr_array_index (_tmp66_, (guint) _tmp67_);
				l = g_list_append (l, (AwnThemedIcon*) _tmp68_);
			}
		}
	}
	_tmp69_ = l;
	{
		GList* ti_collection = NULL;
		GList* ti_it = NULL;
		ti_collection = _tmp69_;
		for (ti_it = ti_collection; ti_it != NULL; ti_it = ti_it->next) {
			AwnThemedIcon* ti = NULL;
			ti = (AwnThemedIcon*) ti_it->data;
			{
				AwnThemedIcon* _tmp70_;
				_tmp70_ = ti;
				simple_launcher_remove_launcher (self, _tmp70_, TRUE);
			}
		}
	}
	_tmp71_ = self->priv->launchers;
	_tmp72_ = g_ptr_array_get_length (_tmp71_);
	_tmp73_ = _tmp72_;
	if (_tmp73_ > 0) {
		AwnThemedIcon* _tmp74_;
		_tmp74_ = self->priv->add_icon;
		gtk_widget_hide ((GtkWidget*) _tmp74_);
	} else {
		AwnThemedIcon* _tmp75_;
		_tmp75_ = self->priv->add_icon;
		gtk_widget_show ((GtkWidget*) _tmp75_);
	}
	something_removed = FALSE;
	{
		gint* _tmp76_;
		gint _tmp76__length1;
		gboolean _tmp77_;
		_tmp76_ = invalid_launchers;
		_tmp76__length1 = invalid_launchers_length1;
		i = _tmp76__length1 - 1;
		_tmp77_ = TRUE;
		while (TRUE) {
			gboolean _tmp78_;
			gint _tmp80_;
			GValueArray* _tmp81_;
			gint* _tmp82_;
			gint _tmp82__length1;
			gint _tmp83_;
			gint _tmp84_;
			_tmp78_ = _tmp77_;
			if (!_tmp78_) {
				gint _tmp79_;
				_tmp79_ = i;
				i = _tmp79_ - 1;
			}
			_tmp77_ = FALSE;
			_tmp80_ = i;
			if (!(_tmp80_ >= 0)) {
				break;
			}
			_tmp81_ = self->priv->_launcher_list;
			_tmp82_ = invalid_launchers;
			_tmp82__length1 = invalid_launchers_length1;
			_tmp83_ = i;
			_tmp84_ = _tmp82_[_tmp83_];
			g_value_array_remove (_tmp81_, (guint) _tmp84_);
			something_removed = TRUE;
		}
	}
	_tmp85_ = something_removed;
	if (_tmp85_) {
		g_object_notify ((GObject*) self, "launcher-list");
	}
	_g_list_free0 (l);
	invalid_launchers = (g_free (invalid_launchers), NULL);
}


static void _simple_launcher_on_launcher_clicked_awn_icon_clicked (AwnIcon* _sender, gpointer self) {
	simple_launcher_on_launcher_clicked (self, _sender);
}


static void _simple_launcher_on_launcher_ctx_menu_awn_icon_context_menu_popup (AwnIcon* _sender, GdkEventButton* event, gpointer self) {
	simple_launcher_on_launcher_ctx_menu (self, _sender, event);
}


static gboolean _simple_launcher_on_launcher_drag_motion_gtk_widget_drag_motion (GtkWidget* _sender, GdkDragContext* context, gint x, gint y, guint time_, gpointer self) {
	gboolean result;
	result = simple_launcher_on_launcher_drag_motion (self);
	return result;
}


static AwnThemedIcon* simple_launcher_create_launcher (SimpleLauncher* self, const gchar* path) {
	AwnThemedIcon* result = NULL;
	const gchar* _tmp0_;
	DesktopAgnosticVFSFile* _tmp1_ = NULL;
	DesktopAgnosticVFSFile* f;
	DesktopAgnosticVFSFile* _tmp2_;
	gboolean _tmp3_ = FALSE;
	DesktopAgnosticVFSFile* _tmp5_;
	DesktopAgnosticFDODesktopEntry* _tmp6_ = NULL;
	DesktopAgnosticFDODesktopEntry* de;
	AwnThemedIcon* _tmp7_;
	AwnThemedIcon* icon;
	AwnThemedIcon* _tmp8_;
	AwnThemedIcon* _tmp9_;
	DesktopAgnosticFDODesktopEntry* _tmp10_;
	DesktopAgnosticFDODesktopEntry* _tmp11_;
	AwnThemedIcon* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gchar* _tmp15_;
	gchar* icon_name;
	DesktopAgnosticFDODesktopEntry* _tmp16_;
	gboolean _tmp17_ = FALSE;
	AwnThemedIcon* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	const gchar* _tmp25_;
	AwnThemedIcon* _tmp26_;
	DesktopAgnosticFDODesktopEntry* _tmp27_;
	gchar* _tmp28_ = NULL;
	gchar* _tmp29_;
	AwnThemedIcon* _tmp30_;
	AwnThemedIcon* _tmp31_;
	AwnIconBox* _tmp32_;
	AwnThemedIcon* _tmp33_;
	AwnThemedIcon* _tmp34_;
	AwnThemedIcon* _tmp35_;
	AwnThemedIcon* _tmp36_;
	GPtrArray* _tmp37_;
	AwnThemedIcon* _tmp38_;
	AwnThemedIcon* _tmp39_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (path != NULL, NULL);
	_tmp0_ = path;
	_tmp1_ = desktop_agnostic_vfs_file_new_for_path (_tmp0_, &_inner_error_);
	f = _tmp1_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp2_ = f;
	_tmp3_ = desktop_agnostic_vfs_file_exists (_tmp2_);
	if (!_tmp3_) {
		const gchar* _tmp4_;
		_tmp4_ = path;
		g_warning ("simple-launcher.vala:396: Desktop file \"%s\" doesn't exist!", _tmp4_);
		result = NULL;
		_g_object_unref0 (f);
		return result;
	}
	_tmp5_ = f;
	_tmp6_ = desktop_agnostic_fdo_desktop_entry_new_for_file (_tmp5_, &_inner_error_);
	de = _tmp6_;
	if (_inner_error_ != NULL) {
		_g_object_unref0 (f);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp7_ = (AwnThemedIcon*) awn_themed_icon_new ();
	g_object_ref_sink (_tmp7_);
	icon = _tmp7_;
	_tmp8_ = icon;
	g_object_set (_tmp8_, "drag-and-drop", FALSE, NULL);
	_tmp9_ = icon;
	_tmp10_ = de;
	_tmp11_ = _g_object_ref0 (_tmp10_);
	g_object_set_data_full ((GObject*) _tmp9_, SIMPLE_LAUNCHER_DESKTOP_ENTRY, _tmp11_, g_object_unref);
	_tmp12_ = icon;
	_tmp13_ = awn_applet_get_size ((AwnApplet*) self);
	_tmp14_ = _tmp13_;
	awn_themed_icon_set_size (_tmp12_, _tmp14_);
	_tmp15_ = g_strdup ("image-missing");
	icon_name = _tmp15_;
	_tmp16_ = de;
	_tmp17_ = desktop_agnostic_fdo_desktop_entry_key_exists (_tmp16_, "Icon");
	if (_tmp17_) {
		DesktopAgnosticFDODesktopEntry* _tmp18_;
		gchar* _tmp19_ = NULL;
		_tmp18_ = de;
		_tmp19_ = desktop_agnostic_fdo_desktop_entry_get_string (_tmp18_, "Icon");
		_g_free0 (icon_name);
		icon_name = _tmp19_;
	}
	_tmp20_ = icon;
	_tmp21_ = awn_applet_get_canonical_name ((AwnApplet*) self);
	_tmp22_ = _tmp21_;
	_tmp23_ = awn_applet_get_uid ((AwnApplet*) self);
	_tmp24_ = _tmp23_;
	_tmp25_ = icon_name;
	awn_themed_icon_set_info_simple (_tmp20_, _tmp22_, _tmp24_, _tmp25_);
	_tmp26_ = icon;
	_tmp27_ = de;
	_tmp28_ = desktop_agnostic_fdo_desktop_entry_get_localestring (_tmp27_, "Name", NULL);
	_tmp29_ = _tmp28_;
	awn_icon_set_tooltip_text ((AwnIcon*) _tmp26_, _tmp29_);
	_g_free0 (_tmp29_);
	_tmp30_ = icon;
	g_signal_connect_object ((AwnIcon*) _tmp30_, "clicked", (GCallback) _simple_launcher_on_launcher_clicked_awn_icon_clicked, self, 0);
	_tmp31_ = icon;
	g_signal_connect_object ((AwnIcon*) _tmp31_, "context-menu-popup", (GCallback) _simple_launcher_on_launcher_ctx_menu_awn_icon_context_menu_popup, self, 0);
	_tmp32_ = self->priv->icon_box;
	_tmp33_ = icon;
	gtk_container_add ((GtkContainer*) _tmp32_, (GtkWidget*) _tmp33_);
	_tmp34_ = icon;
	gtk_widget_show ((GtkWidget*) _tmp34_);
	_tmp35_ = icon;
	gtk_drag_dest_set ((GtkWidget*) _tmp35_, 0, NULL, 0, GDK_ACTION_PRIVATE);
	_tmp36_ = icon;
	g_signal_connect_object ((GtkWidget*) _tmp36_, "drag-motion", (GCallback) _simple_launcher_on_launcher_drag_motion_gtk_widget_drag_motion, self, 0);
	_tmp37_ = self->priv->launchers;
	_tmp38_ = icon;
	_tmp39_ = _g_object_ref0 (_tmp38_);
	g_ptr_array_add (_tmp37_, _tmp39_);
	result = icon;
	_g_free0 (icon_name);
	_g_object_unref0 (de);
	_g_object_unref0 (f);
	return result;
}


static void simple_launcher_remove_launcher (SimpleLauncher* self, AwnThemedIcon* launcher, gboolean delete_desktop_file) {
	AwnThemedIcon* _tmp0_;
	gpointer _tmp1_ = NULL;
	DesktopAgnosticFDODesktopEntry* de;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_;
	gboolean _tmp12_;
	GPtrArray* _tmp16_;
	AwnThemedIcon* _tmp17_;
	AwnThemedIcon* _tmp18_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (launcher != NULL);
	_tmp0_ = launcher;
	_tmp1_ = g_object_steal_data ((GObject*) _tmp0_, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	de = (DesktopAgnosticFDODesktopEntry*) _tmp1_;
	_tmp3_ = delete_desktop_file;
	if (_tmp3_) {
		DesktopAgnosticFDODesktopEntry* _tmp4_;
		DesktopAgnosticVFSFile* _tmp5_;
		DesktopAgnosticVFSFile* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		const gchar* _tmp10_;
		gboolean _tmp11_ = FALSE;
		_tmp4_ = de;
		_tmp5_ = desktop_agnostic_fdo_desktop_entry_get_file (_tmp4_);
		_tmp6_ = _tmp5_;
		_tmp7_ = desktop_agnostic_vfs_file_get_path (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp9_ = _tmp8_;
		_tmp10_ = self->priv->config_dir;
		_tmp11_ = g_str_has_prefix (_tmp9_, _tmp10_);
		_tmp2_ = _tmp11_;
		_g_free0 (_tmp9_);
	} else {
		_tmp2_ = FALSE;
	}
	_tmp12_ = _tmp2_;
	if (_tmp12_) {
		DesktopAgnosticFDODesktopEntry* _tmp13_;
		DesktopAgnosticVFSFile* _tmp14_;
		DesktopAgnosticVFSFile* _tmp15_;
		_tmp13_ = de;
		_tmp14_ = desktop_agnostic_fdo_desktop_entry_get_file (_tmp13_);
		_tmp15_ = _tmp14_;
		desktop_agnostic_vfs_file_remove (_tmp15_, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (de);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
	}
	_tmp16_ = self->priv->launchers;
	_tmp17_ = launcher;
	g_ptr_array_remove (_tmp16_, _tmp17_);
	_tmp18_ = launcher;
	gtk_object_destroy ((GtkObject*) _tmp18_);
	_g_object_unref0 (de);
}


static gboolean __lambda2_ (SimpleLauncher* self) {
	gboolean result = FALSE;
	AwnThemedIcon* _tmp0_;
	_tmp0_ = self->priv->add_icon;
	gtk_widget_hide ((GtkWidget*) _tmp0_);
	result = FALSE;
	return result;
}


static gboolean ___lambda2__gsource_func (gpointer self) {
	gboolean result;
	result = __lambda2_ (self);
	return result;
}


static gboolean simple_launcher_on_launcher_drag_motion (SimpleLauncher* self) {
	gboolean result = FALSE;
	guint _tmp0_;
	guint _tmp2_ = 0U;
	AwnThemedIcon* _tmp3_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->timer_id;
	if (_tmp0_ != ((guint) 0)) {
		guint _tmp1_;
		_tmp1_ = self->priv->timer_id;
		g_source_remove (_tmp1_);
	}
	_tmp2_ = g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 2500, ___lambda2__gsource_func, g_object_ref (self), g_object_unref);
	self->priv->timer_id = _tmp2_;
	_tmp3_ = self->priv->add_icon;
	gtk_widget_show ((GtkWidget*) _tmp3_);
	result = FALSE;
	return result;
}


static void simple_launcher_on_launcher_clicked (SimpleLauncher* self, AwnIcon* launcher) {
	AwnIcon* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	DesktopAgnosticFDODesktopEntry* _tmp2_;
	DesktopAgnosticFDODesktopEntry* de;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (launcher != NULL);
	_tmp0_ = launcher;
	_tmp1_ = g_object_get_data ((GObject*) _tmp0_, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp2_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp1_);
	de = _tmp2_;
	g_return_if_fail (de != NULL);
	{
		AwnIcon* _tmp3_;
		AwnEffects* _tmp4_ = NULL;
		desktop_agnostic_fdo_desktop_entry_launch (de, 0, NULL, &_inner_error_);
		if (_inner_error_ != NULL) {
			goto __catch1_g_error;
		}
		_tmp3_ = launcher;
		_tmp4_ = awn_overlayable_get_effects ((AwnOverlayable*) _tmp3_);
		awn_effects_start_ex (_tmp4_, AWN_EFFECT_LAUNCHING, 1, FALSE, FALSE);
	}
	goto __finally1;
	__catch1_g_error:
	{
		GError* err = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		GtkMessageDialog* _tmp7_;
		GtkMessageDialog* d;
		GtkMessageDialog* _tmp8_;
		GtkMessageDialog* _tmp9_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp5_ = err;
		_tmp6_ = _tmp5_->message;
		_tmp7_ = (GtkMessageDialog*) gtk_message_dialog_new (NULL, GTK_DIALOG_MODAL, GTK_MESSAGE_ERROR, GTK_BUTTONS_CLOSE, "Unable to start launcher!\n\n" "Error details:\n%s", _tmp6_);
		g_object_ref_sink (_tmp7_);
		d = _tmp7_;
		_tmp8_ = d;
		gtk_dialog_run ((GtkDialog*) _tmp8_);
		_tmp9_ = d;
		gtk_object_destroy ((GtkObject*) _tmp9_);
		_g_object_unref0 (d);
		_g_error_free0 (err);
	}
	__finally1:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (de);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	_g_object_unref0 (de);
}


static void simple_launcher_on_launcher_ctx_menu (SimpleLauncher* self, AwnIcon* launcher, GdkEventButton* event) {
	GtkMenuItem* _tmp0_;
	AwnIcon* _tmp1_;
	AwnIcon* _tmp2_;
	GtkMenuItem* _tmp3_;
	AwnIcon* _tmp4_;
	AwnIcon* _tmp5_;
	AwnIcon* _tmp6_;
	GtkMenu* _tmp7_;
	GdkEventButton _tmp8_;
	guint _tmp9_;
	GdkEventButton _tmp10_;
	guint32 _tmp11_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (launcher != NULL);
	g_return_if_fail (event != NULL);
	_tmp0_ = self->priv->remove_menu_item;
	_tmp1_ = launcher;
	_tmp2_ = _g_object_ref0 (_tmp1_);
	g_object_set_data_full ((GObject*) _tmp0_, SIMPLE_LAUNCHER_DESKTOP_ENTRY, _tmp2_, g_object_unref);
	_tmp3_ = self->priv->edit_menu_item;
	_tmp4_ = launcher;
	_tmp5_ = _g_object_ref0 (_tmp4_);
	g_object_set_data_full ((GObject*) _tmp3_, SIMPLE_LAUNCHER_DESKTOP_ENTRY, _tmp5_, g_object_unref);
	_tmp6_ = launcher;
	_tmp7_ = self->priv->menu;
	_tmp8_ = *event;
	_tmp9_ = _tmp8_.button;
	_tmp10_ = *event;
	_tmp11_ = _tmp10_.time;
	awn_icon_popup_gtk_menu (_tmp6_, (GtkWidget*) _tmp7_, _tmp9_, _tmp11_);
}


static void simple_launcher_remove_clicked (SimpleLauncher* self) {
	GtkMenuItem* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	AwnThemedIcon* _tmp2_;
	AwnThemedIcon* ti;
	AwnThemedIcon* _tmp3_;
	gconstpointer _tmp4_ = NULL;
	DesktopAgnosticFDODesktopEntry* _tmp5_;
	DesktopAgnosticFDODesktopEntry* de;
	guint index;
	GValueArray* _tmp6_;
	guint _tmp17_;
	GValueArray* _tmp18_;
	guint _tmp19_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->remove_menu_item;
	_tmp1_ = g_object_get_data ((GObject*) _tmp0_, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp2_ = _g_object_ref0 ((AwnThemedIcon*) _tmp1_);
	ti = _tmp2_;
	_tmp3_ = ti;
	_tmp4_ = g_object_get_data ((GObject*) _tmp3_, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp5_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp4_);
	de = _tmp5_;
	index = (guint) 0;
	_tmp6_ = self->priv->_launcher_list;
	{
		GValueArray* v_collection = NULL;
		guint v_index = 0U;
		v_collection = _tmp6_;
		for (v_index = 0; v_index < v_collection->n_values; v_index = v_index + 1) {
			GValue _tmp7_ = {0};
			GValue v = {0};
			if (G_IS_VALUE (g_value_array_get_nth (v_collection, v_index))) {
				g_value_init (&_tmp7_, G_VALUE_TYPE (g_value_array_get_nth (v_collection, v_index)));
				g_value_copy (g_value_array_get_nth (v_collection, v_index), &_tmp7_);
			} else {
				_tmp7_ = *g_value_array_get_nth (v_collection, v_index);
			}
			v = _tmp7_;
			{
				const gchar* _tmp8_ = NULL;
				DesktopAgnosticFDODesktopEntry* _tmp9_;
				DesktopAgnosticVFSFile* _tmp10_;
				DesktopAgnosticVFSFile* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gboolean _tmp15_;
				guint _tmp16_;
				_tmp8_ = g_value_get_string (&v);
				_tmp9_ = de;
				_tmp10_ = desktop_agnostic_fdo_desktop_entry_get_file (_tmp9_);
				_tmp11_ = _tmp10_;
				_tmp12_ = desktop_agnostic_vfs_file_get_path (_tmp11_);
				_tmp13_ = _tmp12_;
				_tmp14_ = _tmp13_;
				_tmp15_ = g_strcmp0 (_tmp8_, _tmp14_) == 0;
				_g_free0 (_tmp14_);
				if (_tmp15_) {
					G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
					break;
				}
				_tmp16_ = index;
				index = _tmp16_ + 1;
				G_IS_VALUE (&v) ? (g_value_unset (&v), NULL) : NULL;
			}
		}
	}
	_tmp17_ = index;
	_tmp18_ = self->priv->_launcher_list;
	_tmp19_ = _tmp18_->n_values;
	if (_tmp17_ < _tmp19_) {
		GValueArray* _tmp20_;
		guint _tmp21_;
		_tmp20_ = self->priv->_launcher_list;
		_tmp21_ = index;
		g_value_array_remove (_tmp20_, _tmp21_);
	}
	g_object_notify ((GObject*) self, "launcher-list");
	_g_object_unref0 (de);
	_g_object_unref0 (ti);
}


static void simple_launcher_edit_clicked (SimpleLauncher* self) {
	GtkMenuItem* _tmp0_;
	gconstpointer _tmp1_ = NULL;
	AwnThemedIcon* _tmp2_;
	AwnThemedIcon* ti;
	AwnThemedIcon* _tmp3_;
	gconstpointer _tmp4_ = NULL;
	DesktopAgnosticFDODesktopEntry* _tmp5_;
	DesktopAgnosticFDODesktopEntry* de;
	DesktopAgnosticFDODesktopEntry* _tmp6_;
	DesktopAgnosticVFSFile* _tmp7_;
	DesktopAgnosticVFSFile* _tmp8_;
	DesktopAgnosticVFSFile* _tmp9_;
	DesktopAgnosticVFSFile* input;
	DesktopAgnosticVFSFile* output;
	DesktopAgnosticVFSFile* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	const gchar* _tmp14_;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp16_;
	DesktopAgnosticVFSFile* _tmp18_;
	DesktopAgnosticVFSFile* _tmp19_;
	DesktopAgnosticUILauncherEditorDialog* _tmp20_;
	DesktopAgnosticUILauncherEditorDialog* d;
	DesktopAgnosticUILauncherEditorDialog* _tmp21_;
	DesktopAgnosticUILauncherEditorDialog* _tmp22_;
	gint _tmp23_ = 0;
	DesktopAgnosticUILauncherEditorDialog* _tmp47_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->remove_menu_item;
	_tmp1_ = g_object_get_data ((GObject*) _tmp0_, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp2_ = _g_object_ref0 ((AwnThemedIcon*) _tmp1_);
	ti = _tmp2_;
	_tmp3_ = ti;
	_tmp4_ = g_object_get_data ((GObject*) _tmp3_, SIMPLE_LAUNCHER_DESKTOP_ENTRY);
	_tmp5_ = _g_object_ref0 ((DesktopAgnosticFDODesktopEntry*) _tmp4_);
	de = _tmp5_;
	_tmp6_ = de;
	_tmp7_ = desktop_agnostic_fdo_desktop_entry_get_file (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = _g_object_ref0 (_tmp8_);
	input = _tmp9_;
	output = NULL;
	_tmp10_ = input;
	_tmp11_ = desktop_agnostic_vfs_file_get_path (_tmp10_);
	_tmp12_ = _tmp11_;
	_tmp13_ = _tmp12_;
	_tmp14_ = self->priv->config_dir;
	_tmp15_ = g_str_has_prefix (_tmp13_, _tmp14_);
	_tmp16_ = !_tmp15_;
	_g_free0 (_tmp13_);
	if (_tmp16_) {
		DesktopAgnosticVFSFile* _tmp17_ = NULL;
		_tmp17_ = simple_launcher_get_new_desktop_file (self);
		_g_object_unref0 (output);
		output = _tmp17_;
	}
	_tmp18_ = input;
	_tmp19_ = output;
	_tmp20_ = desktop_agnostic_ui_launcher_editor_dialog_new (_tmp18_, _tmp19_, TRUE);
	g_object_ref_sink (_tmp20_);
	d = _tmp20_;
	_tmp21_ = d;
	gtk_widget_show_all ((GtkWidget*) _tmp21_);
	_tmp22_ = d;
	_tmp23_ = gtk_dialog_run ((GtkDialog*) _tmp22_);
	if (_tmp23_ == ((gint) GTK_RESPONSE_APPLY)) {
		DesktopAgnosticVFSFile* _tmp24_;
		_tmp24_ = output;
		if (_tmp24_ == NULL) {
			AwnThemedIcon* _tmp25_;
			_tmp25_ = ti;
			simple_launcher_remove_launcher (self, _tmp25_, FALSE);
			simple_launcher_launchers_changed (self);
		} else {
			GValue* val = NULL;
			{
				guint i;
				i = (guint) 0;
				{
					gboolean _tmp26_;
					_tmp26_ = TRUE;
					while (TRUE) {
						gboolean _tmp27_;
						guint _tmp29_;
						GValueArray* _tmp30_;
						guint _tmp31_;
						GValueArray* _tmp32_;
						guint _tmp33_;
						GValue* _tmp34_ = NULL;
						GValue* _tmp35_;
						const gchar* _tmp36_ = NULL;
						DesktopAgnosticVFSFile* _tmp37_;
						gchar* _tmp38_;
						gchar* _tmp39_;
						gchar* _tmp40_;
						gboolean _tmp41_;
						_tmp27_ = _tmp26_;
						if (!_tmp27_) {
							guint _tmp28_;
							_tmp28_ = i;
							i = _tmp28_ + 1;
						}
						_tmp26_ = FALSE;
						_tmp29_ = i;
						_tmp30_ = self->priv->_launcher_list;
						_tmp31_ = _tmp30_->n_values;
						if (!(_tmp29_ < _tmp31_)) {
							break;
						}
						_tmp32_ = self->priv->_launcher_list;
						_tmp33_ = i;
						_tmp34_ = g_value_array_get_nth (_tmp32_, _tmp33_);
						val = _tmp34_;
						_tmp35_ = val;
						_tmp36_ = g_value_get_string (_tmp35_);
						_tmp37_ = input;
						_tmp38_ = desktop_agnostic_vfs_file_get_path (_tmp37_);
						_tmp39_ = _tmp38_;
						_tmp40_ = _tmp39_;
						_tmp41_ = g_strcmp0 (_tmp36_, _tmp40_) == 0;
						_g_free0 (_tmp40_);
						if (_tmp41_) {
							GValue* _tmp42_;
							DesktopAgnosticVFSFile* _tmp43_;
							gchar* _tmp44_;
							gchar* _tmp45_;
							gchar* _tmp46_;
							_tmp42_ = val;
							_tmp43_ = output;
							_tmp44_ = desktop_agnostic_vfs_file_get_path (_tmp43_);
							_tmp45_ = _tmp44_;
							_tmp46_ = _tmp45_;
							g_value_set_string (_tmp42_, _tmp46_);
							_g_free0 (_tmp46_);
						}
					}
				}
			}
			g_object_notify ((GObject*) self, "launcher-list");
		}
	}
	_tmp47_ = d;
	gtk_object_destroy ((GtkObject*) _tmp47_);
	_g_object_unref0 (d);
	_g_object_unref0 (output);
	_g_object_unref0 (input);
	_g_object_unref0 (de);
	_g_object_unref0 (ti);
}


GValueArray* simple_launcher_get_launcher_list (SimpleLauncher* self) {
	GValueArray* result;
	GValueArray* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_launcher_list;
	result = _tmp0_;
	return result;
}


void simple_launcher_set_launcher_list (SimpleLauncher* self, GValueArray* value) {
	GValueArray* _tmp0_;
	GValueArray* _tmp1_ = NULL;
	g_return_if_fail (self != NULL);
	_tmp0_ = value;
	_tmp1_ = g_value_array_copy (_tmp0_);
	_g_value_array_free0 (self->priv->_launcher_list);
	self->priv->_launcher_list = _tmp1_;
	g_object_notify ((GObject *) self, "launcher-list");
}


static GObject * simple_launcher_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	SimpleLauncher * self;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	GPtrArray* _tmp3_;
	DesktopAgnosticConfigClient* _tmp4_ = NULL;
	DesktopAgnosticConfigClient* _tmp5_;
	DesktopAgnosticConfigClient* _tmp6_;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (simple_launcher_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SIMPLE_LAUNCHER, SimpleLauncher);
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_build_filename (_tmp0_, "awn", "applets", "simple-launcher", NULL, NULL);
	_g_free0 (self->priv->config_dir);
	self->priv->config_dir = _tmp1_;
	_tmp2_ = self->priv->config_dir;
	g_mkdir_with_parents (_tmp2_, 0755);
	_tmp3_ = g_ptr_array_new_with_free_func (_g_object_unref0_);
	_g_ptr_array_unref0 (self->priv->launchers);
	self->priv->launchers = _tmp3_;
	_tmp4_ = awn_config_get_default_for_applet ((AwnApplet*) self, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp6_ = _g_object_ref0 (_tmp5_);
	_g_object_unref0 (self->priv->client);
	self->priv->client = _tmp6_;
	{
		DesktopAgnosticConfigClient* _tmp7_;
		_tmp7_ = self->priv->client;
		desktop_agnostic_config_client_bind (_tmp7_, DESKTOP_AGNOSTIC_CONFIG_GROUP_DEFAULT, "launcher_list", (GObject*) self, "launcher-list", FALSE, DESKTOP_AGNOSTIC_CONFIG_BIND_METHOD_FALLBACK, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == DESKTOP_AGNOSTIC_CONFIG_ERROR) {
				goto __catch2_desktop_agnostic_config_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
		}
	}
	goto __finally2;
	__catch2_desktop_agnostic_config_error:
	{
		GError* err = NULL;
		GError* _tmp8_;
		const gchar* _tmp9_;
		err = _inner_error_;
		_inner_error_ = NULL;
		_tmp8_ = err;
		_tmp9_ = _tmp8_->message;
		g_critical ("simple-launcher.vala:157: Config Error: %s", _tmp9_);
		_g_error_free0 (err);
	}
	__finally2:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	return obj;
}


static void simple_launcher_class_init (SimpleLauncherClass * klass) {
	simple_launcher_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (SimpleLauncherPrivate));
	G_OBJECT_CLASS (klass)->get_property = _vala_simple_launcher_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_simple_launcher_set_property;
	G_OBJECT_CLASS (klass)->constructor = simple_launcher_constructor;
	G_OBJECT_CLASS (klass)->finalize = simple_launcher_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), SIMPLE_LAUNCHER_LAUNCHER_LIST, g_param_spec_boxed ("launcher-list", "launcher-list", "launcher-list", G_TYPE_VALUE_ARRAY, G_PARAM_STATIC_NAME | G_PARAM_STATIC_NICK | G_PARAM_STATIC_BLURB | G_PARAM_READABLE | G_PARAM_WRITABLE));
}


static void simple_launcher_instance_init (SimpleLauncher * self) {
	GValueArray* _tmp0_;
	self->priv = SIMPLE_LAUNCHER_GET_PRIVATE (self);
	self->priv->timer_id = (guint) 0;
	_tmp0_ = g_value_array_new ((guint) 4);
	self->priv->_launcher_list = _tmp0_;
}


static void simple_launcher_finalize (GObject* obj) {
	SimpleLauncher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SIMPLE_LAUNCHER, SimpleLauncher);
	_g_object_unref0 (self->priv->icon_box);
	_g_object_unref0 (self->priv->add_icon);
	_g_object_unref0 (self->priv->menu);
	_g_object_unref0 (self->priv->add_icon_menu);
	_g_object_unref0 (self->priv->remove_menu_item);
	_g_object_unref0 (self->priv->edit_menu_item);
	_g_object_unref0 (self->priv->client);
	_g_free0 (self->priv->config_dir);
	_g_ptr_array_unref0 (self->priv->launchers);
	_g_value_array_free0 (self->priv->_launcher_list);
	G_OBJECT_CLASS (simple_launcher_parent_class)->finalize (obj);
}


GType simple_launcher_get_type (void) {
	static volatile gsize simple_launcher_type_id__volatile = 0;
	if (g_once_init_enter (&simple_launcher_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SimpleLauncherClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) simple_launcher_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SimpleLauncher), 0, (GInstanceInitFunc) simple_launcher_instance_init, NULL };
		GType simple_launcher_type_id;
		simple_launcher_type_id = g_type_register_static (AWN_TYPE_APPLET, "SimpleLauncher", &g_define_type_info, 0);
		g_once_init_leave (&simple_launcher_type_id__volatile, simple_launcher_type_id);
	}
	return simple_launcher_type_id__volatile;
}


static void _vala_simple_launcher_get_property (GObject * object, guint property_id, GValue * value, GParamSpec * pspec) {
	SimpleLauncher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SIMPLE_LAUNCHER, SimpleLauncher);
	switch (property_id) {
		case SIMPLE_LAUNCHER_LAUNCHER_LIST:
		g_value_set_boxed (value, simple_launcher_get_launcher_list (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


static void _vala_simple_launcher_set_property (GObject * object, guint property_id, const GValue * value, GParamSpec * pspec) {
	SimpleLauncher * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SIMPLE_LAUNCHER, SimpleLauncher);
	switch (property_id) {
		case SIMPLE_LAUNCHER_LAUNCHER_LIST:
		simple_launcher_set_launcher_list (self, g_value_get_boxed (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}


AwnApplet* awn_applet_factory_initp (const gchar* canonical_name, const gchar* uid, gint panel_id) {
	AwnApplet* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	SimpleLauncher* _tmp3_;
	g_return_val_if_fail (canonical_name != NULL, NULL);
	g_return_val_if_fail (uid != NULL, NULL);
	_tmp0_ = canonical_name;
	_tmp1_ = uid;
	_tmp2_ = panel_id;
	_tmp3_ = simple_launcher_new (_tmp0_, _tmp1_, _tmp2_);
	g_object_ref_sink (_tmp3_);
	result = (AwnApplet*) _tmp3_;
	return result;
}


static void _vala_array_destroy (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void _vala_array_free (gpointer array, gint array_length, GDestroyNotify destroy_func) {
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



